<?php
/**
* Joomla Community Builder
* @version $Id: comprofiler.class.php 388 2006-08-10 00:26:38Z beat $
* @package Community Builder
* @subpackage comprofiler.class.php
* @author JoomlaJoe and Beat
* @copyright (C) JoomlaJoe and Beat, www.joomlapolis.com
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
*/

// ensure this file is being included by a parent file
defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

$ueConfig['version']='1.0.1';

/** @global int $_CB_OneTwoRowsStyleToggle */
/** @global string $_CB_ProfileItemid */
global $_CB_PMS, $_CB_OneTwoRowsStyleToggle, $_CB__Cache_ProfileItemid;
// $_CB_PMS = new cbPMS();				// moved at end of file
$_CB_OneTwoRowsStyleToggle = 1;			// toggle for status sectionTableEntry display

/**
 * gets Itemid of CB profile, or by default of homepage
 * @param boolean TRUE if should return "&amp:Itemid...." instead of "&Itemid..." (with FALSE as default)
 * @return string "&Itemid=xxx"
 */
function getCBprofileItemid( $htmlspecialchars= false ) {
	global $_CB__Cache_ProfileItemid, $database;
	
	if (!$_CB__Cache_ProfileItemid) {
		if(!isset($_REQUEST['Itemid'])) {
			$database->setQuery("SELECT id FROM #__menu WHERE link = 'index.php?option=com_comprofiler' AND published=1");
			$Itemid = $database->loadResult();
		} else {
			$Itemid = intval($_REQUEST['Itemid']);
		}
		if (!$Itemid) {
			/** Nope, just use the homepage then. */
			$query = "SELECT id"
			. "\n FROM #__menu"
			. "\n WHERE menutype = 'mainmenu'"
			. "\n AND published = 1"
			. "\n ORDER BY parent, ordering"
			. "\n LIMIT 1"
			;
			$database->setQuery( $query );
			$Itemid = $database->loadResult();
		}
		$_CB__Cache_ProfileItemid = $Itemid;
	}
	if ($_CB__Cache_ProfileItemid) {
		return ($htmlspecialchars ? "&amp;" : "&")."Itemid=".$_CB__Cache_ProfileItemid;
	} else {
		return null;
	}
}

/* MAMBO 4.5.2.3 FIXES: */

/**
*	Corrects bugs in mambo core class mosDBTable ! :
*	1) NULL values from SQL tables are not loaded !
*	2) updateOrder method is buggy and does not allow to specify modified row ids to force them into the right position !
*/
class comprofilerDBTable extends mosDBTable {
	/**
	*	Object constructor to set table and key field
	*
	*	Can be overloaded/supplemented by the child class
	*	@param string $table name of the table in the db schema relating to child class
	*	@param string $key name of the primary key field in the table
	*/
	function comprofilerDBTable( $table, $key, &$db ) {
		$this->mosDBTable($table, $key, $db);
	}
	/**
	*	binds an array/hash to this object
	*	@param int $oid optional argument, if not specifed then the value of current key is used
	*	@return any result from the database operation
	*/
	function load( $oid=null ) {
		$k = $this->_tbl_key;
		if ($oid !== null) {
			$this->$k = $oid;
		}
		$oid = $this->$k;
		if ($oid === null) {
			return false;
		}
		
		//BB fix : resets default values to all object variables, because NULL SQL fields do not overide existing variables !
		//Note: Prior to PHP 4.2.0, Uninitialized class variables will not be reported by get_class_vars().
		$class_vars = get_class_vars(get_class($this));
		foreach ($class_vars as $name => $value) {
			if (($name != $k) and ($name != "_db") and ($name != "_tbl") and ($name != "_tbl_key")) {
				$this->$name = $value;
			}
		}
		//end of BB fix.

		return parent::load( $oid );
	}
	
	/** private utility method for updateOrder() back-called by usort() for comparing orderings
	*/
	function _cmp_obj($a, $b) {
		$k = "ordering";
		if ($a->$k == $b->$k) {
           return 0;
       }
       return ($a->$k > $b->$k) ? +1 : -1;
   }
	/**
	* Compacts the ordering sequence of the selected records
	* @param string Additional where query to limit ordering to a particular subset of records
	* @param array of table key ids which should preserve their position (in addition of the negative positions) 
	*/
	function updateOrder( $where='' , $cids=null) {
		$k = $this->_tbl_key;

		if (!array_key_exists( 'ordering', get_class_vars( strtolower(get_class( $this )) ) )) {
			$this->_error = "WARNING: ".strtolower(get_class( $this ))." does not support ordering.";
			return false;
		}

		if ($this->_tbl == "#__content_frontpage") {
			$order2 = ", content_id DESC";
		} else {
			$order2 = "";
		}

		$this->_db->setQuery( "SELECT $this->_tbl_key, ordering FROM $this->_tbl"
		. ($where ? "\nWHERE $where" : '')
		. "\nORDER BY ordering".$order2
		);
		if (!($orders = $this->_db->loadObjectList())) {
			$this->_error = $this->_db->getErrorMsg();
			return false;
		}

		$n=count( $orders );
		$iOfThis = null;
		
		if($cids !== null) {
			$cidsOrderings = array();			// determine list of reserved/changed ordering numbers
			for ($i=0; $i < $n; $i++) {
				if (in_array($orders[$i]->$k, $cids)) {
					$cidsOrderings[$orders[$i]->$k] = $orders[$i]->ordering;
				}
			}

			$j = 1;								// change ordering numbers outside of reserved and negative ordering numbers list
			for ($i=0; $i < $n; $i++) {
				if ($orders[$i]->$k == $this->$k) {
					// place 'this' record in the desired location at the end !
					$iOfThis = $i;
					if ($orders[$i]->ordering == $j) $j++;
				} else if (in_array($orders[$i]->$k, $cids)) {
					if ($orders[$i]->ordering == $j) $j++;
				} else {
					if ($orders[$i]->ordering >= 0) $orders[$i]->ordering = $j++;
					while (in_array($orders[$i]->ordering, $cidsOrderings)) $orders[$i]->ordering = $j++;
				}
			}
		} else {
			$j = 1;
			for ($i=0; $i < $n; $i++) {
				if ($orders[$i]->$k == $this->$k) {
					// place 'this' record in the desired location at the end !
					$iOfThis = $i;
					if ($orders[$i]->ordering == $j) $j++;
				} else if ($orders[$i]->ordering != $this->ordering && $this->ordering > 0 && $orders[$i]->ordering >= 0) {
					$orders[$i]->ordering = $j++;
				} else if ($orders[$i]->ordering == $this->ordering && $this->ordering > 0 && $orders[$i]->ordering >= 0) {
					if ($orders[$i]->ordering == $j) $j++;
					$orders[$i]->ordering = $j++;
				}
			}
		}
		if ($iOfThis !== null) {
			$orders[$iOfThis]->ordering = min( $this->ordering, $j );
		}
		// sort entries by ->ordering:
		usort($orders, array("comprofilerDBTable", "_cmp_obj"));
		
		
		// compact ordering:
		$j = 1;
		for ($i=0; $i < $n; $i++) {
			if ($orders[$i]->ordering >= 0) {
				$orders[$i]->ordering = $j++;
			}
		}

		for ($i=0; $i < $n; $i++) {
			if (($orders[$i]->ordering >= 0) or ($orders[$i]->$k == $this->$k)) {
				$this->_db->setQuery( "UPDATE $this->_tbl"
				. "\nSET ordering='".$orders[$i]->ordering."' WHERE $k='".$orders[$i]->$k."'"
				);
				$this->_db->query();
			}
		}

		// if we didn't find to reorder the current record, make it last
		if (($iOfThis === null) && ($this->ordering > 0)) {
			$order = $n+1;
			$this->_db->setQuery( "UPDATE $this->_tbl"
			. "\nSET ordering='$order' WHERE $k='".$this->$k."'"
			);
			$this->_db->query();
		}
		return true;
	}
}	// end class comprofilerDBTable


/** mosMail():
*	1) was copying BCC fields int CC
*	2) did not include the ReplyTo field, to avoid having to spoof an email address.
*	MF bug id #7713.
*/


/**
* Function to create a mail object for futher use (uses phpMailer)
* @param string From e-mail address
* @param string From name
* @param string E-mail subject
* @param string Message body
* @return object Mail object
*/
function comprofilerCreateMail( $from='', $fromname='', $subject, $body ) {
	global $mosConfig_absolute_path, $mosConfig_sendmail;
	global $mosConfig_smtpauth, $mosConfig_smtpuser;
	global $mosConfig_smtppass, $mosConfig_smtphost;
	global $mosConfig_mailfrom, $mosConfig_fromname, $mosConfig_mailer;

	$mail = new mosPHPMailer();

	$mail->PluginDir = $mosConfig_absolute_path .'/includes/phpmailer/';
	$mail->SetLanguage( 'en', $mosConfig_absolute_path . '/includes/phpmailer/language/' );
	$mail->CharSet 	= substr_replace(_ISO, '', 0, 8);
	$mail->IsMail();
	$mail->From 	= $from ? $from : $mosConfig_mailfrom;
	$mail->FromName = $fromname ? $fromname : $mosConfig_fromname;
	$mail->Mailer 	= $mosConfig_mailer;

	// Add smtp values if needed
	if ( $mosConfig_mailer == 'smtp' ) {
		$mail->SMTPAuth = $mosConfig_smtpauth;
		$mail->Username = $mosConfig_smtpuser;
		$mail->Password = $mosConfig_smtppass;
		$mail->Host 	= $mosConfig_smtphost;
	} else

	// Set sendmail path
	if ( $mosConfig_mailer == 'sendmail' ) {
		if (isset($mosConfig_sendmail))
			$mail->Sendmail = $mosConfig_sendmail;
	} // if

	$mail->Subject 	= $subject;
	$mail->Body 	= $body;

	return $mail;
}

/**
* Mail function (uses phpMailer)
* @param string From e-mail address
* @param string From name
* @param string/array Recipient e-mail address(es)
* @param string E-mail subject
* @param string Message body
* @param boolean false = plain text, true = HTML
* @param string/array CC e-mail address(es)
* @param string/array BCC e-mail address(es)
* @param string/array Attachment file name(s)
* @param string/array ReplyTo e-mail address(es)
* @param string/array ReplyTo name(s)
*/
function comprofilerMail($from, $fromname, $recipient, $subject, $body, $mode=0, $cc=NULL, $bcc=NULL, $attachment=NULL, $replyto=NULL, $replytoname=NULL ) {
	global $mosConfig_debug;
	$mail = comprofilerCreateMail( $from, $fromname, $subject, $body );

	// activate HTML formatted emails
	if ( $mode ) {
		$mail->IsHTML(true);
	}

	if( is_array($recipient) ) {
		foreach ($recipient as $to) {
			$mail->AddAddress($to);
		}
	} else {
		$mail->AddAddress($recipient);
	}
	if (isset($cc)) {
	    if( is_array($cc) )
	        foreach ($cc as $to) $mail->AddCC($to);
	    else
	        $mail->AddCC($cc);
	}
	if (isset($bcc)) {
	    if( is_array($bcc) )
	        foreach ($bcc as $to) $mail->AddBCC($to);
	    else
	        $mail->AddBCC($bcc);
	}
    if ($attachment) {
        if ( is_array($attachment) )
            foreach ($attachment as $fname) $mail->AddAttachment($fname);
        else
            $mail->AddAttachment($attachment);
    } // if
    if ($replyto) {
        if ( is_array($replyto) ) {
        	reset($replytoname);
            foreach ($replyto as $to) {
            	$toname = ((list($key, $value) = each($replytoname)) ? $value : "");
            	$mail->AddReplyTo($to, $toname);
            }
        } else
            $mail->AddReplyTo($replyto, $replytoname);
    }
	$mailssend = $mail->Send();

	if( $mosConfig_debug ) {
		//$mosDebug->message( "Mails send: $mailssend");
	}
	if( $mail->error_count > 0 ) {
		//$mosDebug->message( "The mail message $fromname <$from> about $subject to $recipient <b>failed</b><br /><pre>$body</pre>", false );
		//$mosDebug->message( "Mailer Error: " . $mail->ErrorInfo . "" );
	}
	return $mailssend;
} // mosMail

/** END OF MAMBO CORE BUGS CORRECTIONS !
*/


class moscomprofilerPlugin extends comprofilerDBTable {
	/** @var int */
	var $id=null;
	/** @var varchar */
	var $name=null;
	/** @var varchar */
	var $element=null;
	/** @var varchar */
	var $type=null;
	/** @var varchar */
	var $folder=null;
	/** @var tinyint unsigned */
	var $access=null;
	/** @var int */
	var $ordering=null;
	/** @var tinyint */
	var $published=null;
	/** @var tinyint */
	var $iscore=null;
	/** @var tinyint */
	var $client_id=null;
	/** @var int unsigned */
	var $checked_out=null;
	/** @var datetime */
	var $checked_out_time=null;
	/** @var text */
	var $params=null;
	/**
	* Constructor
	*/
	function moscomprofilerPlugin( &$db ) {
		$this->comprofilerDBTable( '#__comprofiler_plugin', 'id', $db );
	}
}

class moscomprofilerHTML extends mosHTML {

	function radioListArr( &$arr, $tag_name, $tag_attribs, $key, $text, $selected, $required=0 ) {
		reset( $arr );
		$html = array();
		for ($i=0, $n=count( $arr ); $i < $n; $i++ ) {
			$k = stripslashes($arr[$i]->$key);
			$t = stripslashes($arr[$i]->$text);
			$id = isset($arr[$i]->id) ? $arr[$i]->id : null;

			$extra = '';
			$extra .= $id ? " id=\"" . $arr[$i]->id . "\"" : '';
			if (is_array( $selected )) {
				foreach ($selected as $obj) {
					$k2 = stripslashes($obj->$key);
					if ($k == $k2) {
						$extra .= " checked=\"checked\"";
						break;
					}
				}
			} else {
				$extra .= ($k == stripslashes($selected) ? "  checked=\"checked\"" : '');
			}
			if($i==0) $isReq="mosReq=\"".$required."\"";
			else $isReq="";
			$html[] = "<input type=\"radio\" name=\"$tag_name\" $isReq $tag_attribs value=\"".$k."\"$extra /> " . getLangDefinition($t);
		}
		return $html;
	}
	function radioList( $arr, $tag_name, $tag_attribs, $key, $text, $selected, $required=0 ) {
		return "\n\t".implode("\n\t ", moscomprofilerHTML::radioListArr( $arr, $tag_name, $tag_attribs, $key, $text, $selected, $required ))."\n";
	}
	function radioListTable( $arr, $tag_name, $tag_attribs, $key, $text, $selected, $cols=0, $rows=1, $size=0, $required=0 ) {
		$cellsHtml = moscomprofilerHTML::radioListArr( $arr, $tag_name, $tag_attribs, $key, $text, $selected, $required );
		return moscomprofilerHTML::list2Table( $cellsHtml, $cols, $rows, $size );
	}
	function selectList( $arr, $tag_name, $tag_attribs, $key, $text, $selected, $required=0 ) {
		reset( $arr );
		$html = "\n<select name=\"$tag_name\" $tag_attribs>";
		if(!$required) $html .= "\n\t<option value=\"\"> </option>";

		for ($i=0, $n=count( $arr ); $i < $n; $i++ ) {
			$k = stripslashes($arr[$i]->$key);
			$t = stripslashes($arr[$i]->$text);
			$id = isset($arr[$i]->id) ? $arr[$i]->id : null;

			$extra = '';
			$extra .= $id ? " id=\"" . $arr[$i]->id . "\"" : '';
			if (is_array( $selected )) {
				foreach ($selected as $obj) {
					$k2 = stripslashes($obj->$key);
					if ($k == $k2) {
						$extra .= " selected=\"selected\"";
						break;
					}
				}
			} else {
				$extra .= ($k == stripslashes($selected) ? " selected=\"selected\"" : '');
			}
			$html .= "\n\t<option value=\"".$k."\"$extra>";
			$html .= getLangDefinition($t);
			$html .= "</option>";
		}
		$html .= "\n</select>\n";
		return $html;
	}
	function checkboxListArr( $arr, $tag_name, $tag_attribs,  $key='value', $text='text',$selected=null, $required=0  ) {
		reset( $arr );
		$html = array();
		for ($i=0, $n=count( $arr ); $i < $n; $i++ ) {
			$k = $arr[$i]->$key;
			$t = $arr[$i]->$text;
			$id = isset($arr[$i]->id) ? $arr[$i]->id : null;

			$extra = '';
			$extra .= $id ? " id=\"" . $arr[$i]->id . "\"" : '';
			if (is_array( $selected )) {
				foreach ($selected as $obj) {
					$k2 = $obj->$key;
					if ($k == $k2) {
						$extra .= " checked=\"checked\"";
						break;
					}
				}
			} else {
				$extra .= ($k == $selected ? " checked=\"checked\"" : '');
			}
			if($i==0) $isReq=$required;
			else $isReq=0;
			$html[] = "<input type=\"checkbox\" name=\"$tag_name\" mosReq=\"$isReq\" value=\"".$k."\"$extra $tag_attribs />" . getLangDefinition($t);
		}
		return $html;
	}
	function checkboxList( $arr, $tag_name, $tag_attribs,  $key='value', $text='text',$selected=null, $required=0 ) {
		return "\n\t".implode("\n\t", moscomprofilerHTML::checkboxListArr( $arr, $tag_name, $tag_attribs,  $key, $text,$selected, $required ))."\n";
	}
	function checkboxListTable( $arr, $tag_name, $tag_attribs,  $key='value', $text='text',$selected=null, $cols=0, $rows=0, $size=0, $required=0 ) {
		$cellsHtml = moscomprofilerHTML::checkboxListArr( $arr, $tag_name, $tag_attribs,  $key, $text,$selected, $required );
		return moscomprofilerHTML::list2Table( $cellsHtml, $cols, $rows, $size );
	}
	// private methods:
	function list2Table ( $cellsHtml, $cols, $rows, $size ) {
		$cells = count($cellsHtml);
		if ($size == 0) {
			$localstyle = ""; //" style='width:100%'";
		} else {
			$size = (($size-($size % 3)) / 3  ) * 2; // int div  3 * 2 width/heigh ratio
			$localstyle = " style='width:".$size."em;'";
		}
		$return="";
		if ($cells) {
			if ($rows) {
				$return = "\n\t<table class='cbMulti'".$localstyle.">";
				$cols = ($cells-($cells % $rows)) / $rows;	// int div
				if ($cells % $rows) $cols++;
				$lineIdx=0;
				for ($lineIdx=0 ; $lineIdx < min($rows, $cells) ; $lineIdx++) {
					$return .= "\n\t\t<tr>";
					for ($i=$lineIdx ; $i < $cells; $i += $rows) {
						$return .= "<td>".$cellsHtml[$i]."</td>";
					}
					$return .= "</tr>\n";
				}
				$return .= "\t</table>\n";
			} else if ($cols) {
				$return = "\n\t<table class='cbMulti'".$localstyle.">";
				$idx=0;
				while ($cells) {
					$return .= "\n\t\t<tr>";
					for ($i=0, $n=min($cells,$cols); $i < $n; $i++, $cells-- ) {
						$return .= "<td>".$cellsHtml[$idx++]."</td>";
					}
					$return .= "</tr>\n";
				}
				$return .= "\t</table>\n";
			} else {
				$return = "\n\t".implode("\n\t ", $cellsHtml)."\n";
			}
		}
		return $return;
	}
} // end class moscomprofilerHTML

class moscomprofilerLists extends comprofilerDBTable {

   var $listid=null;
   var $title=null;
   var $description=null;
   var $published=null;
   var $default=null;
   var $usergroupids=null;
   var $useraccessgroupid=null;
   var $sortfields=null; 
   var $filterfields=null; 
   var $ordering=null;  
   var $col1title=null;
   var $col1enabled=null;
   var $col1fields=null;
   var $col1captions=null;
   var $col2title=null;
   var $col2enabled=null;
   var $col2fields=null;
   var $col2captions=null;
   var $col3title=null;
   var $col3enabled=null;
   var $col3fields=null;
   var $col3captions=null;
   var $col4title=null;
   var $col4enabled=null;
   var $col4fields=null;
   var $col4captions=null;

    /**
    * Constructor
    * @param database A database connector object
    */
	function moscomprofilerLists( &$db ) {
	
		$this->comprofilerDBTable( '#__comprofiler_lists', 'listid', $db );
	
	} //end func

	function store( $listid=0, $updateNulls=false) {
			global $database, $_POST;
	
		if(!isset($_POST['listid']) || $_POST['listid']==null || $_POST['listid']=='') $this->listid =$listid;
		else $this->listid=$_POST['listid'];
		$sql="Select count(*) from #__comprofiler_lists where listid = '".  cbGetEscaped($this->listid)."'";
		$database->SetQuery($sql);
		$total = $database->LoadResult();
		if($this->default==1) {
			$sql="UPDATE #__comprofiler_lists SET `default` = 0";
			$database->SetQuery($sql);
			$database->query();
		}
			if( $total > 0 ) {
				// existing record
				$ret = $this->_db->updateObject( $this->_tbl, $this, $this->_tbl_key, $updateNulls );
				
			} else {
				// new record
				$sql="Select max(ordering) from #__comprofiler_lists";
				$database->SetQuery($sql);
				$max = $database->LoadResult();
				$this->ordering=$max+1;
				$this->listid = null;
				$ret = $this->_db->insertObject( $this->_tbl, $this, $this->_tbl_key );
			}
			if( !$ret ) {
				$this->_error = get_class( $this )."::store failed <br />" . $this->_db->getErrorMsg();
				return false;
			} else {
				return true;
			}
	}


} //end class

class moscomprofilerFields extends comprofilerDBTable {

   var $fieldid=null;
   var $name=null;
   var $title=null;
   var $description=null;
   var $type=null;
   var $maxlength=null;
   var $size=null;
   var $required=null;
   var $tabid=null;
   var $ordering=null;
   var $cols=null;
   var $rows=null;
   var $value=null;
   var $default=null;
   var $sys=null;
   var $profile=null;
   var $published=null;
   var $readonly=null;
   var $registration=null;
   var $table=null;
   var $params=null;

    /**
    * Constructor
    * @param database A database connector object
    */
	function moscomprofilerFields( &$db ) {
	
		$this->comprofilerDBTable( '#__comprofiler_fields', 'fieldid', $db );
	
	} //end func
	
	function store( $fieldid=0, $updateNulls=false) {
			global $database, $_POST;

			$this->fieldid =$fieldid;

			SWITCH($this->type) {
				CASE 'date':
					$cType='DATE';
				break;
				CASE 'editorta':
				CASE 'textarea':
				CASE 'multiselect':
				CASE 'multicheckbox':
					$cType='MEDIUMTEXT';
				break;	
				CASE 'checkbox':
					$cType='TINYINT';
				break;			
				default:
					$cType='VARCHAR(255)';
				break;
			}

			$sql="Select count(*) from #__comprofiler_fields where fieldid = '".  cbGetEscaped($this->fieldid)."'";
			$database->SetQuery($sql);
			$total = $database->LoadResult();

			if( $total > 0 ) {
				// existing record
				//echo "updating";
				$ret = $this->_db->updateObject( $this->_tbl, $this, $this->_tbl_key, $updateNulls );	// escapes values
				if ($ret) {
					$ret = $this->changeColumn('#__comprofiler',$this->name,$cType);
				}
			} else {
				// new record
				//echo "inserting";
				$sql="SELECT COUNT(*) FROM #__comprofiler_fields WHERE name='".$this->name."'";
				$database->SetQuery($sql);
				if($database->LoadResult() > 0) {
					$this->_error = "The field name ".$this->name." is already in use!";
					return false;
				}				
				$sql="Select max(ordering) from #__comprofiler_fields WHERE tabid=".$this->tabid;
				$database->SetQuery($sql);
				$max = $database->LoadResult();
				$this->ordering=$max+1;
				$this->fieldid = null;
				$ret = $this->createColumn('#__comprofiler',$this->name,$cType);
				if ($ret) {
					$ret = $this->_db->insertObject( $this->_tbl, $this, $this->_tbl_key );		// do inserObject last to keep insertId intact
				}
			}
			if( !$ret ) {
				$this->_error = get_class( $this )."::store failed <br />" . $this->_db->getErrorMsg();
				return false;
			} else {
				return true;
			}
	}
	/**
	*	Delete method for fields deleting also fieldvalues, but not the data column in the comprofiler table.
	*	For that, deleteColumn() method must be called separately.
	*
	*	@param id of row to delete
	*	@return true if successful otherwise returns and error message
	*/
	function delete( $oid=null ) {
		$k = $this->_tbl_key;
		if ($oid) {
			$this->$k = intval( $oid );
		}

		$result = true;
		
		//Find all fieldValues related to the field
		$this->_db->setQuery("SELECT `fieldvalueid` FROM #__comprofiler_field_values WHERE `fieldid`=".$this->$k);
		$fieldvalues=$this->_db->loadObjectList();
		$rowFieldValues=new moscomprofilerFieldValues($this->_db);
		if(count($fieldvalues)>0) {
			//delete each field value related to a field
			foreach($fieldvalues AS $fieldvalue) {
				$result = $rowFieldValues->delete($fieldvalue->fieldvalueid) && $result;
			}	
		}
		//Now delete the field itself without deleting the user data, preserving it for reinstall
		//$rowField->deleteColumn('#__comprofiler',$field->name);	// this would delete the user data
		$result = parent::delete($this->$k) && $result;
		return $result;
	}

	function createColumn( $table, $column, $type) {
			global $database;
		$sql="SELECT * FROM `$table` LIMIT 1";
		$database->setQuery($sql);
		$obj = null;
		if (!($database->loadObject($obj) && isset($obj->$column))) {
			$sql="ALTER TABLE `$table` ADD `$column` $type";
			$database->SetQuery($sql);
			//echo "before";
			$ret = $database->query();
			//echo "after";
				if( !$ret ) {
					$this->_error .= get_class( $this )."::createColumn failed <br />" . $this->_db->getErrorMsg();
					return false;
				} else {
					return true;
				}
		} else {
			return $this->changeColumn( $table, $column, $type);
			
		}
	}

	function changeColumn( $table, $column, $type) {
			global $database;
		$sql="ALTER TABLE `$table` CHANGE `$column` `$column` $type";
		$database->SetQuery($sql);
		//echo "before";
		$ret = $database->query();
		//echo "after";
			if( !$ret ) {
				$this->_error .= get_class( $this )."::changeColumn failed <br />" . $this->_db->getErrorMsg();
				return false;
			} else {
				return true;
			}
	}

	function deleteColumn( $table, $column) {
			global $database;
		$sql="ALTER TABLE `$table` DROP `$column`";
		$database->SetQuery($sql);
		$ret = $database->query();
			if( !$ret ) {
				$this->_error .= get_class( $this )."::deleteColumn failed <br />" . $this->_db->getErrorMsg();
				return false;
			} else {
				return true;
			}
	}
} //end class

class moscomprofilerTabs extends comprofilerDBTable {

   var $tabid=null;
   var $title=null;
   var $description=null;
   var $ordering=null;
   var $width=null;
   var $enabled=null;
   var $pluginclass=null;
   var $pluginid=null;
   var $fields=null;
   var $params=null;
   /**	@var system tab: >=1: from comprofiler core: can't be deleted. ==2: always enabled. ==3: collecting element (menu+status): rendered at end. */
   var $sys=null;
   var $position=null;
   var $displaytype=null;

    /**
    * Constructor
    * @param database A database connector object
    */
	function moscomprofilerTabs( &$db ) {
	
		$this->comprofilerDBTable( '#__comprofiler_tabs', 'tabid', $db );
	
	} //end func

	function store( $tabid, $updateNulls=false) {
			global $database, $_POST;
	
		if(!isset($_POST['tabid']) || $_POST['tabid']==null || $_POST['tabid']=='') $this->tabid =$tabid;
		else $this->tabid=$_POST['tabid'];
		$sql="Select count(*) from #__comprofiler_tabs where tabid = '".  cbGetEscaped($this->tabid)."'";
		$database->SetQuery($sql);
		$total = $database->LoadResult();
			if( $total > 0 ) {
				// existing record
				$ret = $this->_db->updateObject( $this->_tbl, $this, $this->_tbl_key, $updateNulls );	// escapes values!
				
			} else {
				$sql="Select max(ordering) from #__comprofiler_tabs";
				$database->SetQuery($sql);
				$max = $database->LoadResult();
				$this->ordering=$max+1;
				// new record
				$this->tabid = null;
				$ret = $this->_db->insertObject( $this->_tbl, $this, $this->_tbl_key );
				
			}
			if( !$ret ) {
				$this->_error = get_class( $this )."::store failed <br />" . $this->_db->getErrorMsg();
				return false;
			} else {
				return true;
			}
	}
} //end class

class moscomprofilerFieldValues extends comprofilerDBTable {
   var $fieldvalueid=null;
   var $fieldid=null;
   var $fieldtitle=null;
   var $sys=null;

    /**
    * Constructor
    * @param database A database connector object
    */

	function moscomprofilerFieldValues( &$db ) {
	
		$this->comprofilerDBTable( '#__comprofiler_field_values', 'fieldvalueid', $db );
	
	} //end func

	function store( $fieldvalueid=0, $updateNulls=false) {
			global $database, $_POST;
	
		if(!isset($_POST['fieldvalueid']) || $_POST['fieldvalueid']==null || $_POST['fieldvalueid']=='') $this->fieldvalueid = $fieldvalueid;
		else $this->fieldvalueid=$_POST['fieldvalueid'];
		$sql="Select count(*) from #__comprofiler_field_values where fieldvalueid = '".  cbGetEscaped($this->fieldvalueid)."'";
		$database->SetQuery($sql);
		$total = $database->LoadResult();
			if( $total > 0 ) {
				// existing record
				$ret = $this->_db->updateObject( $this->_tbl, $this, $this->_tbl_key, $updateNulls );
				
			} else {
				// new record
				$this->fieldvalueid = null;
				$ret = $this->_db->insertObject( $this->_tbl, $this, $this->_tbl_key );
			}
			if( !$ret) {
				$this->_error = get_class( $this )."::store failed <br />" . $this->_db->getErrorMsg();
				return false;
			} else {
				
				return true;
			}
	}


} //end class


class moscomprofiler extends comprofilerDBTable {

   // IMPORTANT: ALL VARIABLES HERE MUST BE NULL in order to not be updated if not set.
   var $id=null;
   var $user_id=null;
   var $avatar=null;
   var $avatarapproved=null;
   var $approved=null;
   var $confirmed=null;
   var $hits=null;

    /**
    * Constructor
    * @param database A database connector object
    */

	function moscomprofiler( &$db ) {
	
		$this->comprofilerDBTable( '#__comprofiler', 'id', $db );
	
	} //end func

	function storeExtras( $id=0, $updateNulls=false) {
		global $database, $_POST;
	
		if(!isset($_POST['id']) || $_POST['id']==null || $_POST['id']=='') $this->id =$id;
		else $this->id=$_POST['id'];
		$sql="Select count(*) from #__comprofiler where id = '".  cbGetEscaped($this->id)."'";
		$database->SetQuery($sql);
		$total = $database->LoadResult();
			if( $total > 0 ) {
				// existing record
				$ret = $this->_db->updateObject( $this->_tbl, $this, $this->_tbl_key, $updateNulls );	// escapes values!
				
			} else {
				// new record
				$sql="Select max(id) from #__users";
				$database->SetQuery($sql);
				$last_id = $database->LoadResult();
				$this->id = $last_id;
				$this->user_id = $last_id;
				$ret = $this->_db->insertObject( $this->_tbl, $this, $this->_tbl_key );					// escapes values!
				
			}
			if( !$ret ) {
				$this->_error = get_class( $this )."::store failed <br />" . $this->_db->getErrorMsg();
				return false;
			} else {
				return true;
			}
	}
	/**
	*	Merges two object into one by reference ( avoids "_db", "_tbl", "_tbl_key", and $o2->($o2->_tbl_key) )
	*   @static function:
	*	@param object $o1 first object
	*	@param object $o2 second object
	*	@return object
	*/
	function & dbObjectsMerge( &$o1, &$o2 ) {
		$r = new stdClass();
		
		$class_vars = get_object_vars($o1);
		foreach ($class_vars as $name => $value) {
			if (($name != "_db") and ($name != "_tbl") and ($name != "_tbl_key")) {
				$r->$name =& $o1->$name;
			}
		}
		$class_vars = get_object_vars($o2);
		$k = $o2->_tbl_key;
		foreach ($class_vars as $name => $value) {
			if (($name != $k) and ($name != "_db") and ($name != "_tbl") and ($name != "_tbl_key")) {
				$r->$name =& $o2->$name;
			}
		}
		return $r;
	}

} //end class

class moscomprofilerUserReport extends comprofilerDBTable {

   var $reportid=null;
   var $reporteduser=null;
   var $reportedbyuser=null;
   var $reportedondate=null;
   var $reportexplaination=null;

    /**
    * Constructor
    * @param database A database connector object
    */
	function moscomprofilerUserReport( &$db ) {
	
		$this->comprofilerDBTable( '#__comprofiler_userreports', 'reportid', $db );
	
	} //end func


} //end class


//FUNCTIONS

function deleteAvatar($avatar){
	global $mosConfig_absolute_path;
   	if(eregi("gallery/",$avatar)==false && is_file($mosConfig_absolute_path."/images/comprofiler/".$avatar)) {
		@unlink($mosConfig_absolute_path."/images/comprofiler/".$avatar);
		if(is_file($mosConfig_absolute_path."/images/comprofiler/tn".$avatar)) @unlink($mosConfig_absolute_path."/images/comprofiler/tn".$avatar);
	}
}

/**
 * Activates an inactive user
 * @param object mos+cbUser
 */
function activateUser(&$user, $mailToAdmins = true, $mailToUser = true) {
	global $database, $ueConfig, $_PLUGINS;
	
	$query = "UPDATE #__users"
	. "\n SET block = 0, activation = ''"
	. "\n WHERE id = '".$user->id."'"
	// . "\n WHERE activation = '$activation'"
	// . "\n AND block = 1"
	;
	$database->setQuery( $query );
	if (!$database->query()) {
		echo "SQL-unblock error: " . $database->stderr(true);
	}
	$cbNotification = new cbNotification();
	if($mailToAdmins && $ueConfig['moderatorEmail']==1) {
		$cbNotification->sendToModerators(_UE_REG_ADMIN_SUB,$cbNotification->_replaceVariables(_UE_REG_ADMIN_MSG,$user));
	}
	$_PLUGINS->trigger( 'onUserActive', array($user,true));
	if ($mailToUser) {
		$cbNotification->sendFromSystem($user,getLangDefinition($ueConfig['reg_welcome_sub']),getLangDefinition($ueConfig['reg_welcome_msg']));
	}
}

/**
* Page navigation support functions
*/

/**
* Writes the html links for pages, eg, previous 1 2 3 ... x next
* @param int The record number to start dislpaying from
* @param int Number of rows to display per page
* @param int Total number of rows
* @param string base url (without SEF): sefRelToAbs done inside this function
* @param mixed string/array : string: search parameter added as &$prefix.search=... if NOT NULL ; array: each added as $prefix.&key=$val
* @param string prefix on the &limitstart and &search URL items
*/

function writePagesLinks($limitstart, $limit, $total,$ue_base_url,$search=null,$prefix="") {
	$ret="";
	if (is_array($search)) {
		$search_str = "";
		foreach ($search as $k => $v) {
			if ($v && $k!="limitstart")  $search_str .= "&amp;".urlencode($prefix.$k)."=".urlencode($v);
		}
	} else {
		$search_str = (($search) ? "&amp;".urlencode($prefix)."search=".urlencode($search) : "");
	}
	$limstart_str = "&amp;".urlencode($prefix)."limitstart=";
	$pages_in_list = 9;                // set how many pages you want displayed in the menu (not including first&last, and ev. ... repl by single page number.
	$displayed_pages = $pages_in_list;
	$total_pages = ceil( $total / $limit );
	$this_page = ceil( ($limitstart+1) / $limit );
	// $start_loop = (floor(($this_page-1)/$displayed_pages))*$displayed_pages+1;
	$start_loop = $this_page-floor($displayed_pages/2); if ($start_loop < 1) $start_loop = 1; if ($start_loop == 3) $start_loop = 2;		//BB
	if ($start_loop + $displayed_pages - 1 < $total_pages-2) {
		$stop_loop = $start_loop + $displayed_pages - 1;
	} else {
		$stop_loop = $total_pages;
	}

	if ($this_page > 1) {
		$page = ($this_page - 2) * $limit;
		$ret .= "\n<a class=\"pagenav\" href=\"".sefRelToAbs($ue_base_url.$limstart_str."0".$search_str)."\" title=\"" . _UE_FIRST_PAGE . "\">&lt;&lt; " . _UE_FIRST_PAGE . "</a>";
		$ret .= "\n<a class=\"pagenav\" href=\"".sefRelToAbs($ue_base_url.$limstart_str.$page.$search_str)."\" title=\"" . _UE_PREV_PAGE . "\">&lt; " . _UE_PREV_PAGE . "</a>";
		if ($start_loop > 1) $ret .= "\n<a class=\"pagenav\" href=\"".sefRelToAbs($ue_base_url.$limstart_str."0".$search_str)."\" title=\"" . _UE_FIRST_PAGE . "\"><strong>1</strong></a>";
		if ($start_loop > 2) $ret .= "\n<span class=\"pagenav\"> <strong>...</strong> </span>";
	} else {
			$ret .= '<span class="pagenav">&lt;&lt; '. _UE_FIRST_PAGE .'</span> ';
			$ret .= '<span class="pagenav">&lt; '. _UE_PREV_PAGE .'</span> ';
		}

	for ($i=$start_loop; $i <= $stop_loop; $i++) {
		$page = ($i - 1) * $limit;
		if ($i == $this_page) {
			$ret .= "\n <span class=\"pagenav\">[".$i."]</span> ";
		} else {
			$ret .= "\n<a class=\"pagenav\" href=\"".sefRelToAbs($ue_base_url.$limstart_str.$page.$search_str)."\"><strong>$i</strong></a>";
		}
	}

	if ($this_page < $total_pages) {
		$page = $this_page * $limit;
		$end_page = ($total_pages-1) * $limit;
		if ($stop_loop < $total_pages-1) $ret .= "\n<span class=\"pagenav\"> <strong>...</strong> </span>";
		if ($stop_loop < $total_pages) $ret .= "\n<a class=\"pagenav\" href=\"".sefRelToAbs($ue_base_url.$limstart_str.$end_page.$search_str)."\" title=\"" . _UE_END_PAGE . "\"><strong>".$total_pages."</strong></a>";
		$ret .= "\n<a class=\"pagenav\" href=\"".sefRelToAbs($ue_base_url.$limstart_str.$page.$search_str)."\" title=\"" . _UE_NEXT_PAGE . "\">" . _UE_NEXT_PAGE . " &gt;</a>";
		$ret .= "\n<a class=\"pagenav\" href=\"".sefRelToAbs($ue_base_url.$limstart_str.$end_page.$search_str)."\" title=\"" . _UE_END_PAGE . "\">" . _UE_END_PAGE . " &gt;&gt;</a>";
	} else {
		$ret .= '<span class="pagenav">'. _UE_NEXT_PAGE .' &gt;</span> ';
		$ret .= '<span class="pagenav">'. _UE_END_PAGE .' &gt;&gt;</span>';
	}
	return $ret;
}

/**
* Writes the html for the pages counter, eg, Results 1-10 of x
*
* @param int The record number to start dislpaying from
* @param int Number of rows to display per page
* @param int Total number of rows
*/
function writePagesCounter($limitstart, $limit, $total) {
	$from_result = $limitstart+1;
	if ($limitstart + $limit < $total) {
		$to_result = $limitstart + $limit;
	} else {
		$to_result = $total;
	}
	if ($total > 0) {
		echo _UE_RESULTS . " <b>" . $from_result . " - " . $to_result . "</b> " . _UE_OF_TOTAL . " <b>" . $total . "</b>";
	} else {
		echo _UE_NO_RESULTS . ".";
	}
}
function isOdd($x){
if($x & 1) return TRUE;
else return FALSE;
}
function check_filesize($file,$maxSize) {

   $size = filesize($file);

   if($size <= $maxSize) {
      return true;
   }
   return false;
}

function check_image_type($type)
{
   switch( $type )
   {
      case 'jpeg':
      case 'pjpeg':
      case 'jpg':
         return '.jpg';
         break;
      case 'png':
         return '.png';
         break;
   }

   return false;
}

function display_avatar_gallery($avatar_gallery_path)
{
   $dir = @opendir($avatar_gallery_path);
   $avatar_images = array();
   $avatar_col_count = 0;
   while( $file = @readdir($dir) )
   {

      if( $file != '.' && $file != '..' && is_file($avatar_gallery_path . '/' . $file) && !is_link($avatar_gallery_path. '/' . $file) )
      {
            if( preg_match('/(\.gif$|\.png$|\.jpg|\.jpeg)$/is', $file) )
            {
               $avatar_images[$avatar_col_count] = $file;
               // $avatar_name[$avatar_col_count] = ucfirst(str_replace("_", " ", preg_replace('/^(.*)\..*$/', '\1', $file)));
               $avatar_col_count++;
            }
       }
   }

   @closedir($dir);

   @ksort($avatar_images);
   @reset($avatar_images);

   return $avatar_images;
}

function fmodReplace($x,$y)
{ //function provided for older PHP versions which do not have an fmod function yet
   $i = floor($x/$y);
   return $x - $i*$y;
}




function dateConverter($oDate,$oFromFormat,$oToFormat) {
	if($oDate=="" || $oDate == null || !isset($oDate)) {
		return "";
	} else {
		$specChar = array(".","/");
		$oDate = str_replace($specChar,"-",$oDate);
		$oFromFormat = str_replace($specChar,"-",$oFromFormat);
		$oDate=explode(" ",$oDate);
		if (!ISSET($oDate[1])) $oDate[1]="";
		$dateParts=explode("-",$oDate[0]);
		$fromParts=explode("-",$oFromFormat);

		$dateArray = array();
		$dateArray[$fromParts[0]] = $dateParts[0];
		$dateArray[$fromParts[1]] = $dateParts[1];
		$dateArray[$fromParts[2]] = $dateParts[2];

		if (strpos($oToFormat,"/")!=false) $char = "/";
		elseif (strpos($oToFormat,".")!=false) $char = ".";
		else $char = "-";

		$toParts=explode($char,$oToFormat);

		$returnDate=$oToFormat;
		foreach ($toParts as $toPart) {
			if($toPart=='Y' || $toPart=='y') {
			if(array_key_exists($toPart,$dateArray)) $returnDate=str_replace($toPart,$dateArray[$toPart],$returnDate);
			elseif($toPart=='y')$returnDate=str_replace($toPart,substr($dateArray['Y'],2,2),$returnDate);
			else $returnDate=str_replace($toPart,$dateArray['y'],$returnDate);
		}else {
			$returnDate=str_replace($toPart,substr($dateArray[$toPart],0,2),$returnDate);			
		}
	}
	return $returnDate." ".$oDate[1];
	}

}
function cbFormatDate( $date ) {
	global $ueConfig;
	if ($date!='' && $date!=null && $date!='0000-00-00 00:00:00' && $date!='0000-00-00') {
		$offsettedDate = mosFormatDate($date, "%Y-%m-%d %H:%M:%S");
		$ret = dateConverter($offsettedDate,'Y-m-d',$ueConfig['date_format']);
	} else {
		$ret = "";
	}
	return $ret;
}
function getNameFormat($name,$uname,$format) {
	SWITCH ($format) {
		CASE 1 :
			$returnName = unHtmlspecialchars($name);
		break;
		CASE 2 :
			$returnName = unHtmlspecialchars($name)." (".$uname.")";
		break;
		CASE 3 :
			$returnName = $uname;
		break;
		CASE 4 :
			$returnName = $uname." (".unHtmlspecialchars($name).")";
		break;
	}
	return htmlspecialchars($returnName);
}
function getLangDefinition($text) {
	if(defined($text)) $returnText = constant($text); 
	else $returnText = $text;
	return $returnText;
}
function getFieldValue( $oType, $oValue=null, $user=null, $prefix=null, $imgMode=0, $linkURL=null ) {
	global $ueConfig,$database,$mosConfig_lang,$mosConfig_absolute_path,$my;
	$oReturn="";
	SWITCH ($oType){
		CASE 'checkbox':
			if($oValue!='' && $oValue!=null) {
				if($oValue==1) { $oReturn=_UE_YES; 
				} elseif($oValue==0) { $oReturn=_UE_NO;
				} else { $oReturn=null; }
			}
		break;
		CASE 'select':
		CASE 'radio':
			$oReturn = getLangDefinition($oValue);
		break;
		CASE 'multiselect':
		CASE 'multicheckbox':
			$oReturn=array();
			$oReturn = explode("|*|",$oValue);
			for($i = 0; $i < count($oReturn); $i++) {
   				$oReturn[$i]=getLangDefinition($oReturn[$i]);
			}
			$oReturn = implode(";",$oReturn);
		break;
		CASE 'date':
			if($oValue!='' || $oValue!=null) {
				if ($oValue!='0000-00-00 00:00:00' && $oValue!='0000-00-00') {
					$oReturn = dateConverter($oValue,'Y-m-d',$ueConfig['date_format']);
				} else {
					$oReturn = "";
				}
			}
		break;
		CASE 'primaryemailaddress':
			IF($ueConfig['allow_email_display']==3 || $imgMode != 0) $oValueText=_UE_SENDEMAIL;
			ELSE $oValueText=$oValue;
			$emailIMG="<img src=\"components/com_comprofiler/images/email.gif\" border=\"0\" alt=\"".$oValueText."\" title=\"".$oValueText."\" />";
			SWITCH($imgMode) {
				CASE 0:
					$linkItem=$oValueText;
				break;
				CASE 1:
					$linkItem=$emailIMG;
				break;
				CASE 2:
					$linkItem=$emailIMG.' '.$oValueText;
				break;
			}
			//if no email or 4 (do not display email) then return empty string
			IF($oValue==null || $ueConfig['allow_email_display']==4 || ($imgMode!=0 && $ueConfig['allow_email_display']==1) ) $oReturn="";
			ELSE {
				SWITCH($ueConfig['allow_email_display']){
					CASE 1: //display email only
						//if emailCloaking is support then use it
						IF(is_callable(array("mosHTML","emailCloaking"))) $oReturn = mosHTML::emailCloaking( $oValue, 0 );
						ELSE $oReturn=$oValue;		
					break;
					CASE 2: //mailTo link
						IF($imgMode==0 && is_callable(array("mosHTML","emailCloaking"))) $oReturn = mosHTML::emailCloaking( $oValue, 1, $linkItem, 0 );
						ELSE $oReturn="<a href=\"mailto:".$oValue."\" title=\""._UE_MENU_SENDUSEREMAIL_DESC."\">".$linkItem."</a>";
					break;
					CASE 3: //email Form
						$oReturn="<a href=\"".sefRelToAbs("index.php?option=com_comprofiler&amp;task=emailUser&amp;uid=".$user->id.getCBprofileItemid(true))."\" title=\""._UE_MENU_SENDUSEREMAIL_DESC."\">".$linkItem."</a>";
					break;
				}
			}
		break;
		CASE 'pm':
			$pmIMG="<img src=\"components/com_comprofiler/images/pm.gif\" border=\"0\" alt=\""._UE_PM_USER."\" title=\""._UE_PM_USER."\" />";
			$oReturn="";
			global $_CB_PMS;
			$resultArray = $_CB_PMS->getPMSlinks($user->id, $my->id, "", "", 1);	// toid,fromid,subject,message,1: link to compose new PMS message for $toid user.
			if (count($resultArray) > 0) {
				foreach ($resultArray as $res) {
				 	if (is_array($res)) {
						switch ($imgMode) {
							case 0:
								$linkItem=getLangDefinition($res["caption"]);
							break;
							case 1:
								$linkItem=$pmIMG;
							break;
							case 2:
								$linkItem=$pmIMG.' '.getLangDefinition($res["caption"]);
							break;
						}
						$oReturn .= "<a href=\"".sefRelToAbs($res["url"])."\" title=\"".getLangDefinition($res["tooltip"])."\">".$linkItem."</a>";
				 	}
				}
			}			
		break;
		CASE 'emailaddress':
			IF($oValue==null) $oReturn="";
			elseif (is_callable(array("mosHTML","emailCloaking"))) {		// 	/* Mambo 4.5.0 support: */
				IF($ueConfig['allow_email']==1) $oReturn = mosHTML::emailCloaking( $oValue, 1, $oValue, 0 );
				ELSE $oReturn = mosHTML::emailCloaking( $oValue, 0 );
			} else {
				IF($ueConfig['allow_email']==1)	$oReturn="<a href=\"mailto:".$oValue."\">".$oValue."</a>";
				ELSE $oReturn=$oValue;
			}
		break;
		CASE 'webaddress':
			IF($oValue==null) $oReturn="";
			ELSEIF($ueConfig['allow_website']==1) {
				$oReturn=array();
				$oReturn = explode("|*|",$oValue);
				if (count($oReturn) < 2) $oReturn[1]=$oReturn[0];
				$oReturn="<a href=\"http://".htmlspecialchars($oReturn[0])."\" target=\"_blank\">".htmlspecialchars($oReturn[1])."</a>";
			} ELSE {
				$oReturn=$oValue;
			}
		break;
		CASE 'image':
			if(is_dir($mosConfig_absolute_path."/components/com_comprofiler/plugin/language/".$mosConfig_lang."/images")) $fileLang=$mosConfig_lang;
			else $fileLang="default_language";
			
			if($user->avatarapproved==0) $oValue="components/com_comprofiler/plugin/language/".$fileLang."/images/tnpendphoto.jpg";
			elseif(($user->avatar=='' || $user->avatar==null) && $user->avatarapproved==1) $oValue = "components/com_comprofiler/plugin/language/".$fileLang."/images/tnnophoto.jpg";
			elseif(strpos($user->avatar,"gallery/")===false) $oValue="images/comprofiler/tn".$oValue;
			else $oValue="images/comprofiler/".$oValue;

			if(!is_file($mosConfig_absolute_path."/".$oValue)) $oValue = "components/com_comprofiler/plugin/language/".$fileLang."/images/tnnophoto.jpg";
			if(is_file($mosConfig_absolute_path."/".$oValue)) {
				$onclick = null;
				$aTag = null;
				if($ueConfig['allow_profilelink']==1) {
					$profileURL = sefRelToAbs("index.php?option=com_comprofiler&amp;task=userProfile&amp;user=".$user->id.getCBprofileItemid(true));
					// $onclick = "onclick=\"javascript:window.location='".$profileURL."'\"";
					$aTag = "<a href=\"".$profileURL."\">";
				}
				$oReturn = $aTag."<img src=\"".$oValue. "\" ".$onclick." alt=\"\" style=\"border-style: none;\" />".($aTag ? "</a>" : "");
			}
		break;
		CASE 'status':
			$database->setQuery("SELECT COUNT(*) FROM #__session WHERE userid =".$user->id." AND guest = 0");
			$isonline = $database->loadResult();
			if($isonline > 0) { 
				$oValue = _UE_ISONLINE;
				$onlineIMG= "<img src=\"components/com_comprofiler/images/online.gif\" border=\"0\" alt=\"".$oValue."\" title=\"".$oValue."\" />";
			} else { 
				$oValue = _UE_ISOFFLINE;
				$onlineIMG= "<img src=\"components/com_comprofiler/images/offline.gif\" border=\"0\" alt=\"".$oValue."\" title=\"".$oValue."\" />";
			}
			SWITCH($imgMode) {
				CASE 0:
					$oReturn=$oValue;
				break;
				CASE 1:
					$oReturn=$onlineIMG;
				break;
				CASE 2:
					$oReturn=$onlineIMG.' '.$oValue;
				break;
			}
		break;
		CASE 'formatname':
			if ($linkURL && $ueConfig['allow_profilelink']==1) $oReturn = "<a href=\"".$linkURL."\">";
			$oReturn .= getNameFormat($user->name,$user->username,$ueConfig['name_format']);
			if ($linkURL && $ueConfig['allow_profilelink']==1) $oReturn .= "</a>";
		break;
		CASE 'textarea':
			$oReturn = nl2br($oValue);
		break;
		CASE 'delimiter':
			$oReturn = '';
		break;
		CASE 'editorta':
			$oReturn = $oValue;	//str_replace("&quot;",'"',$oValue);	// corrects double-escapings of " in mysql_escape_string used in j! db.
		break;
		CASE 'predefined':
			if ($linkURL && $ueConfig['allow_profilelink']==1) $oReturn = "<a href=\"".$linkURL."\">";
			$oReturn .= htmlspecialchars(unHtmlspecialchars($oValue));		// needed for jos_users:name (has &039; instead of ' in it...)
			if ($linkURL && $ueConfig['allow_profilelink']==1) $oReturn .= "</a>";
		break;
		DEFAULT:
			$oReturn = htmlspecialchars($oValue);	//htmlspecialchars(str_replace("&quot;",'"',$oValue));	// corrects double-escapings of " in mysql_escape_string used in j! db.
		break;	
	}
	if($prefix != null && ($oReturn != null || $oReturn != '')) $oReturn = $prefix.$oReturn;
	return $oReturn;
}

/**
* Returns full path to template directory
* @param int user interface : 1: frontend, 2: backend
* @return template directory path with trailing '/'
*/
function selectTemplate($ui) {
	global $mosConfig_live_site, $ueConfig;

	if ($ui==1) $templatedir=$ueConfig['templatedir'];
	else $templatedir="luna";

	return $mosConfig_live_site . '/components/com_comprofiler/plugin/templates/'.$templatedir.'/';
}

/** CORRECTION FOR OLD-STYLE TEMPLATES:
*/
/**
* Outputs an arbitrary html text into head tags if possible and configured, otherwise echo it.
* @param string html text for header
*/
function addCbHeadTag($ui,$text) {
	global $mainframe, $ueConfig;
	if ($ui==1 && method_exists($mainframe,"addCustomHeadTag") && isset($ueConfig['xhtmlComply']) && $ueConfig['xhtmlComply']) {
		$mainframe->addCustomHeadTag($text);
	} else {
		echo $text;
	}
}
/**
* Outputs an arbitrary html text into head tags if possible and configured, otherwise echo it.
* @param int user interface : 1: frontend, 2: backend
*/
function outputCbTemplate($ui) {
		addCbHeadTag($ui, '<link type="text/css" rel="stylesheet" href="' . selectTemplate($ui) . 'template.css" />');
}

function utf8RawUrlDecode ($source) {
	$decodedStr = ''; 
	$pos = 0; 
	$len = strlen ($source); 
	while ($pos < $len) { 
		$charAt = substr ($source, $pos, 1); 
		if ($charAt=='%') { 
			$pos++; 
			$charAt = substr ($source, $pos, 1); 
			if ($charAt=='u') { // we got a unicode character 
				$pos++; 
				$unicodeHexVal = substr ($source, $pos, 4); 
				$unicode = hexdec ($unicodeHexVal); 
				$entity = "&#". $unicode . ';'; 
				$decodedStr .= utf8_encode ($entity); 
				$pos += 4; 
			} else { // we have an escaped ascii character 
				$hexVal = substr ($source, $pos, 2); 
				$decodedStr .= chr (hexdec ($hexVal)); 
				$pos += 2; 
			} 
		} else { 
			$decodedStr .= $charAt; 
			$pos++; 
		} 
	} 
	return $decodedStr;
}

class cbHtmlFilterOld {
	function process($string) {
		return strip_tags( $string );
	}
}
/**
 * Utility function to return a value from a named array or a specified default.
 * TO CONTRARY OF JOOMLA mosGetParam:
 * 1) DOES NOT MODIFY ORIGINAL ARRAY
 * @param array A named array
 * @param string The key to search for
 * @param mixed The default value to give if no key found
 * @param int An options mask: _MOS_NOTRIM prevents trim, _MOS_ALLOWHTML allows safe html, _MOS_ALLOWRAW allows raw input
 */
define( "_CB_NOTRIM", 0x0001 );
//define( "_MOS_ALLOWHTML", 0x0002 );
define( "_CB_ALLOWRAW", 0x0004 );
function cbGetParam( $arr, $name, $def=null, $mask=0 ) {
	global $database;
	
	static $noHtmlFilter = null;
	// static $safeHtmlFilter = null;

	if (isset( $arr[$name] )) {
		$ret = $arr[$name];
		if (is_string( $ret )) {
			if (!($mask&_CB_NOTRIM)) {
				$ret = trim( $ret );
			}
			if ($mask&_CB_ALLOWRAW) {
				// do nothing
			} else {
				if (is_null( $noHtmlFilter )) {
					if (class_exists("InputFilter")) {		// Mambo 4.5.0 compatibility
						$noHtmlFilter = new InputFilter( /* $tags, $attr, $tag_method, $attr_method, $xss_auto */ );
					} else {
						$noHtmlFilter = new cbHtmlFilterOld;
					}
				}
				$ret = $noHtmlFilter->process( $ret );
			}
			if (!get_magic_quotes_gpc()) {
				$ret = addslashes( $ret );
			}
		}
		return $ret;
	} else {
		return $def;
	}
}

/** Escapes with database escaping algorythm if magic_quotes are not set */
function cbGetEscaped( $string ) {
	global $database;
	if (get_magic_quotes_gpc()==1) {
		return ( $string );
	} else {
		return ( $database->getEscaped( $string ) );
	}
}

/** Unescapes from PHP escaping algorythm if magic_quotes are set */
function cbGetUnEscaped( $string ) {
	if (get_magic_quotes_gpc()==1) {
		// if (ini_get('magic_quotes_sybase')) return str_replace("''","'",$string);
		return ( stripslashes( $string ));			// this does not handle it correctly if magic_quotes_sybase is ON.
	} else {
		return ( $string );
	}
}

/** Unescapes SQL string except % and _ . So it's reverse of $database->getEscaped... */
function cbUnEscapeSQL($string) {
	return str_replace(array("\\0","\\n","\\r","\\\\","\\'","\\\"","\\Z"),array("\x00","\n","\r","\\","'","\"","\x1a"),$string);
}

/** Escapes SQL search strings. To be used only on escaped strings */
function cbEscapeSQLsearch( $string ) {
	return str_replace(array("%","_"),array("\\%","\\_"), $string );
}

/** Unescapes SQL search strings */
function cbUnEscapeSQLsearch( $string ) {
	return str_replace(array("\\%","\\_"),array("%","_"), $string );
}

function unAmpersand($text) {
	return str_replace("&amp;","&", $text);
}

function unHtmlspecialchars($text) {
	// if (strpos($text, "&lt;") !== false) {
	return str_replace(array("&amp;","&quot;","&#039;","&lt;","&gt;"), array("&","\"","'","<",">"), $text);
	// } else {
	//	return $text;
	// }
}

function unhtmlentities ($string, $quotes, $charset) {
	if ((phpversion() < '5.0.0') && ((phpversion() < '4.3.0') || !((strncmp($charset,"ISO-8859",8)==0) || ereg("125",$charset)))) {
		// For 4.1.0 =< PHP < 4.3.0 use this function instead of html_entity_decode: also php < 5.0 does not support UTF-8 outputs !
		$trans_tbl = get_html_translation_table (HTML_ENTITIES);
		$trans_tbl = array_flip ($trans_tbl);
		return strtr ($string, $trans_tbl);
	} else  {
		return html_entity_decode ($string, $quotes, $charset);
	}
}

function utf8ToISO ($string) {
	$iso = str_replace(array("charset="), array(""),_ISO);
	if ($iso == "UTF-8") {
		return $string;
	} else if (strncmp($iso,"ISO-8859-1",9)==0) {
		return utf8_decode($string);
	} else {
		return unhtmlentities(htmlentities($string,ENT_NOQUOTES,"UTF-8"),ENT_NOQUOTES,$iso);
	}
}

function cbReadDirectory($path) {
	$arr = array();
//	print $path;
	if (!@is_dir( $path )) {
		return $arr;
	}
	$handle = opendir( $path );
	while ($file = readdir($handle)) {
		$dir = mosPathName( $path.'/'.$file, false );
	//	print $dir;
		if(is_dir( $dir )) {
			if (($file <> ".") && ($file <> "..")) {
				//print $file;
				$arr[] = trim( $file );
			}
		}
	}
	closedir($handle);
	asort($arr);
	return $arr;
}


/**
* Utility function to include ToolTips and set defaults for CB
* @param int user interface : 1: frontend, 2: backend
* @param string width of tooltips
* @returns HTML code for init ToolTip in head section
*/
function initToolTip( $ui, $width='250' ) {
	$tip='<script type="text/javascript" src="'.(($ui==2) ? ('../') : ("")) . 'components/com_comprofiler/js/overlib_mini.js"></script>'
	."\n".'<script type="text/javascript" src="'.(($ui==2) ? ('../') : ("")) . 'components/com_comprofiler/js/overlib_hideform_mini.js"></script>'
	."\n".'<script type="text/javascript" src="'.(($ui==2) ? ('../') : ("")) . 'components/com_comprofiler/js/overlib_anchor_mini.js"></script>'
	."\n".'<script type="text/javascript" src="'.(($ui==2) ? ('../') : ("")) . 'components/com_comprofiler/js/overlib_centerpopup_mini.js"></script>'
	."\n".'<script type="text/javascript">'
	.'overlib_pagedefaults(WIDTH,'.$width.',VAUTO,RIGHT,AUTOSTATUSCAP, CSSCLASS,'
	.'TEXTFONTCLASS,\'cb-tips-font\',FGCLASS,\'cb-tips-fg\',BGCLASS,\'cb-tips-bg\''
	.',CAPTIONFONTCLASS,\'cb-tips-capfont\', CLOSEFONTCLASS, \'cb-tips-closefont\');'
	."</script>\n";
	return $tip;
}
	// This function is partly "repeated" here for mambo 4.5 backwards compatibility.
	// Corrected: VAUTO, AUTOSTATUS, <img> tag xhtml 1.0 trans compatibility.

	/**
* Utility function to provide ToolTips
* @param int user interface : 1: frontend, 2: backend
* @param string ToolTip text
* @param string Box title
* @returns HTML code for ToolTip
*/
function CB45_mosToolTip( $ui, $tooltip, $title='', $width='', $image='tooltip.png', $htmltext='', $href='', $style='', $olparams='',$click=false ) {
	if ( $width ) $width = ', WIDTH, \''.$width .'\'';
	if ( $title ) $title = ', CAPTION, \''.$title .'\'';
	if ( $olparams ) $olparams = ', '.$olparams;
	if ($click) {
		$tooltipcode = "onclick=\"return overlib('" . $tooltip . "'". $title . $width . $olparams . ");\" ";
	} else {
		$tooltipcode = "onmouseover=\"return overlib('" . $tooltip . "'". $title . $width . $olparams . ");\" onmouseout=\"return nd();\" ";
	}
	if ( !$htmltext ) {
		if ($image == 'tooltip.png') $style = 'style="border:0" width="16" height="16" alt="i" title=""';
		$image 	= selectTemplate($ui). $image;
		if ($href) $htmltext = '<img src="'. $image .'" '. $style . ' />';
	}
	if ( $href ) {
		$tip 	= "<a href=\"". $href . '" ' . $tooltipcode . $style .">". $htmltext ."</a>";
	} else {
		if ($htmltext) {
			$tip 	= "<span " . $tooltipcode . $style . ">" . $htmltext ."</span>";
		} else {
			$tip 	= '<img src="'. $image .'" ' . $style . " " . $tooltipcode . " />";
		}
	}
	return $tip;
}

function cbFieldTip($ui, $fieldTip, $tipTitle='', $width='', $image='tooltip.png', $htmltext='', $href='', $style='', $olparams='',$click=false) {
	// overlib_mini does not support newlines:
	if (strpos($fieldTip, "&lt;") === false) {
		$fieldTip = str_replace("\r\n", "&lt;br /&gt;", $fieldTip);	
		$fieldTip = str_replace("\n", "&lt;br /&gt;", $fieldTip);
	} else {
		$fieldTip = str_replace("\r\n", " ", $fieldTip);	
		$fieldTip = str_replace("\n", " ", $fieldTip);
	}
	$fieldTip = str_replace(array('"','<','>',"\\"), array("&quot;","&lt;","&gt;","\\\\"), $fieldTip);
	$tipTitle = str_replace(array('"','<','>',"\\"), array("&quot;","&lt;","&gt;","\\\\"), $tipTitle);
	$fieldTip = str_replace(array("'","&#039;"), "\\'", $fieldTip);
	$tipTitle = str_replace(array("'","&#039;"), "\\'", $tipTitle);
	return CB45_mosToolTip($ui, $fieldTip, $tipTitle, $width, $image, $htmltext, $href, $style, $olparams,$click);
}


function getFieldIcons($ui, $oReq, $oProfile, $oDescription="", $oTitle="", $showLabels=false) {
	$templatePath = selectTemplate($ui);
	$oReturn = "";
	if($oDescription) $oReturn .= " ".cbFieldTip($ui, getLangDefinition($oDescription), getLangDefinition($oTitle) );
	if ($showLabels) $oReturn .= " ".cbFieldTip($ui, _UE_FIELDDESCRIPTION, "?")." "._UE_FIELDDESCRIPTION." | ";
	if($oReq) $oReturn .= " <img src='".$templatePath."required.gif' width='16' height='16' alt='*' title='"._UE_FIELDREQUIRED."' />";
	if ($showLabels) $oReturn .= " "._UE_FIELDREQUIRED." | ";
	if($oProfile) $oReturn .= " <img src='".$templatePath."profiles.gif' width='16' height='16' alt='+' title='"._UE_FIELDONPROFILE."' />";		
	if( $showLabels) $oReturn .= " "._UE_FIELDONPROFILE." | ";
	if((!$oProfile) or $showLabels) $oReturn .= " <img src='".$templatePath."noprofiles.gif' width='16' height='16' alt='-' title='"._UE_FIELDNOPROFILE."' />";
	if( $showLabels) $oReturn .= " "._UE_FIELDNOPROFILE;
	return "<span class='cbFieldIcons".(($showLabels) ? "Labels" : "")."'>".$oReturn."</span>";
}

function getFieldEntry($ui,&$calendars,$oType,$oName,$oDescription,$oTitle,$oValue,$oReq,$oLabel,$oID,$oSize, $oMaxLen, $oCols, $oRows,$oProfile, $rowFieldValues=null,$oReadOnly=0) {
global $ueConfig,$database,$mosConfig_live_site;
		if($oSize > 0) $pSize=" size='".$oSize."' ";
		else $pSize="";
		if($oMaxLen > 0) $pMax=" maxlength='".$oMaxLen."' ";	
		else $pMax="";
		if($oCols > 0) $pCols=" cols='".$oCols."' ";	
		else $pCols="";
		if($oRows > 0) $pRows=" rows='".$oRows."' ";	
		else $pRows="";
		if($oReadOnly > 0) { 
			$pReadOnly=" disabled=\"disabled\" ";
			$oReq=0;
		} else { 
			$pReadOnly="";
		}
		$displayFieldIcons = true;
		SWITCH ($oType){
			CASE 'text':
				$oReturn = "<input class=\"inputbox\" $pReadOnly mosReq=\"".$oReq."\" mosLabel=\"".getLangDefinition($oLabel)."\" $pSize $pMax type=\"text\" name=\"".$oName."\" value=\"".htmlspecialchars($oValue)."\" />";
			break;
			CASE 'textarea':
				$oReturn = "<textarea class=\"inputbox\" $pReadOnly mosReq=\"".$oReq."\" $pMax mosLabel=\"".getLangDefinition($oLabel)."\" $pCols $pRows  name=\"".$oName."\">".htmlspecialchars($oValue)."</textarea>";
			break;
			CASE 'editorta':
				if(!($oReadOnly > 0)) {
					ob_start();
					editorArea( 'editor'.$oName ,  $oValue , $oName , 500, 350, $oCols, $oRows ) ;
					$oReturn=ob_get_contents();
					ob_end_clean();
					$oReturn .= ' <script type="text/javascript"> document.adminForm.'.$oName.".setAttribute('mosReq',".$oReq."); document.adminForm.".$oName.".setAttribute('mosLabel','".getLangDefinition($oLabel)."'); </script>";
				} else {
					$oReturn = $oValue;
				}
			break;
			CASE 'select':
			CASE 'multiselect':
			CASE 'radio':
			CASE 'multicheckbox':
				$oReturn = $rowFieldValues;
			break;
			CASE 'checkbox':
				$checked='';
				if($oValue!='' && $oValue != null && $oValue==1) $checked=" checked=\"checked\"";
				$oReturn = "<input class=\"inputbox\" $pReadOnly mosReq=\"".$oReq."\" mosLabel=\"".getLangDefinition($oLabel)."\" type=\"checkbox\" $checked name=\"".$oName."\" value=\"1\" />";		
			break;
			CASE 'hidden':
				$oReturn = "<input class=\"inputbox\" $pReadOnly mosLabel=\"".getLangDefinition($oLabel)."\" type=\"hidden\" name=\"".$oName."\" value=\"".htmlspecialchars($oValue)."\" />";
			break;
			CASE 'password':
				$oReturn = "<input class=\"inputbox\" $pReadOnly mosReq=\"".$oReq."\" mosLabel=\"".getLangDefinition($oLabel)."\" type=\"password\" name=\"".$oName."\" value=\"".htmlspecialchars($oValue)."\" />";
			break;
			CASE 'date':
				$oReturn = $calendars->cbAddCalendar($oName,$oLabel,$oReq,$oValue,$oReadOnly);
			break;
			CASE 'emailaddress':
				$oReturn = "<input class=\"inputbox\" $pReadOnly $pMax mosReq=\"".$oReq."\" $pSize mosLabel=\"".getLangDefinition($oLabel)."\" type=\"text\" name=\"".$oName."\" id=\"".$oName."\" value=\"".htmlspecialchars($oValue)."\" />";
			break;
			CASE 'webaddress':
				if ($oRows!=2) {
					$oReturn = "<input class=\"inputbox\" $pReadOnly $pMax $pSize mosReq=\"".$oReq."\" mosLabel=\"".getLangDefinition($oLabel)."\" type=\"text\" name=\"".$oName."\" id=\"".$oName."\" value=\"".htmlspecialchars($oValue)."\" />";
				} else {
					$oValuesArr=array();
					$oValuesArr = explode("|*|",$oValue);
					if (count($oValuesArr) < 2) $oValuesArr[1]="";
					$oReturn = "<span class=\"webUrlSpan\">";
					$oReturn .= "<span class=\"subTitleSpan\">"._UE_WEBURL.":</span>";
					$oReturn .= "<span class=\"subFieldSpan\"><input class=\"inputbox\" $pReadOnly $pMax $pSize mosReq=\"".$oReq."\" mosLabel=\"".getLangDefinition($oLabel)."\" type=\"text\" name=\"".$oName."\" id=\"".$oName."\" value=\"".htmlspecialchars($oValuesArr[0])."\" />";
					$oReturn .= getFieldIcons($ui, $oReq, $oProfile, $oDescription, $oTitle)."</span>";
					$displayFieldIcons = false;
					
					$oReturn .= "</span><span class=\"webTextSpan\">";
					$oReturn .= "<span class=\"subTitleSpan\">"._UE_WEBTEXT.":</span>";
					$oReturn .= "<span class=\"subFieldSpan\"><input class=\"inputbox\" $pReadOnly $pMax $pSize mosReq=\"".$oReq."\" mosLabel=\"".getLangDefinition($oLabel)."\" type=\"text\" name=\"".$oName."Text\" id=\"".$oName."Text\" value=\"".htmlspecialchars($oValuesArr[1])."\" /></span>";
					$oReturn .= "</span>";
				}			
				break;
			CASE 'delimiter':
				$oReturn = '';
		
		}
		if ($oReturn and $displayFieldIcons) $oReturn .= getFieldIcons($ui, $oReq, $oProfile, $oDescription, $oTitle);
		return $oReturn;
}

   function allowAccess( $accessgroupid,$recurse, $usersgroupid) {
   		global $database;
	  if ($accessgroupid == -2 || ($accessgroupid == -1 && $usersgroupid > 0)) {
	//grant public access or access to all registered users
         return true;
      }
      else {
	//need to do more checking based on more restrictions
         if( $usersgroupid == $accessgroupid ) {
         //direct match
         return true;
         }
         else {
            if ($recurse=='RECURSE') {
               //check if there are children groups

               //$groupchildren=$acl->get_group_children( $usersgroupid, 'ARO', $recurse );
				//print_r($groupchildren);
				$groupchildren=array();
				$groupchildren=getParentGIDS($accessgroupid);
               if ( is_array( $groupchildren ) && count( $groupchildren ) > 0) {
                  if ( in_array($usersgroupid, $groupchildren) ) {
                     //match
                     return true;
                  }
               }
            }
         }
	     //deny access
		return false;
		}
	}

	/**
	 * Check Joomla/Mambo version for API
	 *
	 * @return int API version: =0 = mambo 4.5.0-4.5.3+Joomla 1.0.x, =1 = Joomla! 1.1, >1 newever ones: maybe compatible, <0: -1: Mambo 4.6
	 */
	function checkJversion() {
		global $_VERSION;
		if ($_VERSION->PRODUCT == "Mambo") {
			if (strncasecmp($_VERSION->RELEASE, "4.6", 3)) {
				$version = 0;
			} else {
				$version = -1;
			}
		} elseif ($_VERSION->PRODUCT == "Joomla!") {
			if (strncasecmp($_VERSION->RELEASE, "1.0", 3)) {
				$version = 1;
			} else {
				$version = 0;
			}
		}
		return $version;
	}

	function getChildGIDS($gid) {
			global $database;
			if (checkJversion() <= 0) {
               	$query="SELECT g1.group_id, g1.name"
				."\n FROM #__core_acl_aro_groups g1"
				."\n LEFT JOIN #__core_acl_aro_groups g2 ON g2.lft >= g1.lft"
				."\n WHERE g2.group_id =".$gid
				."\n ORDER BY g1.name";
			} else {
               	$query="SELECT g1.id AS group_id, g1.name"
				."\n FROM #__core_acl_aro_groups g1"
				."\n LEFT JOIN #__core_acl_aro_groups g2 ON g2.lft >= g1.lft"
				."\n WHERE g2.id =".$gid
				."\n ORDER BY g1.name";
			}
				$standardlist=array(-2,);
				if( $gid > 0) $standardlist[]=-1;
               	$array=array();
               	$database->setQuery( $query );
               	$array=$database->loadResultArray();
				$array=array_merge($array,$standardlist);
				return $array;
	}
	
		function getParentGIDS($gid) {
			global $database;
 			if (checkJversion() <= 0) {
              	$query="SELECT g1.group_id, g1.name"
				."\n FROM #__core_acl_aro_groups g1"
				."\n LEFT JOIN #__core_acl_aro_groups g2 ON g2.lft <= g1.lft"
				."\n WHERE g2.group_id =".$gid
				."\n ORDER BY g1.name";
 			} else {
              	$query="SELECT g1.id AS group_id, g1.name"
				."\n FROM #__core_acl_aro_groups g1"
				."\n LEFT JOIN #__core_acl_aro_groups g2 ON g2.lft <= g1.lft"
				."\n WHERE g2.id =".$gid
				."\n ORDER BY g1.name";
 			}
              	$array=array();
               	$database->setQuery( $query );
				$array=$database->loadResultArray();
				return $array;
	}

/**	Gives credits display for frontend and backend
*	@param int	1=frontend, 2=backend
*/
function teamCredits($ui) {
global $ueConfig;
?>
		<table style="width=:100%;border0;align:center;padding:8px;" cellpadding="0" cellspacing="0">
		<tr>
			<td bgcolor="#FFFFFF"> 
				<table width="100%" border="0" align="center" cellpadding="2" cellspacing="0">
				<tr>
					<td style="text-align:center" colspan="2">
					<?php
					if ($ui == 2) {
						echo '<a href="http://www.joomlapolis.com" target="_blank"><img src="../components/com_comprofiler/images/smcblogo.gif" /></a><br />';
						update_checker();
					} else {
						echo "<b>"._UE_SITE_POWEREDBY."</b><br />";
						echo '<a href="http://www.joomlapolis.com" target="_blank" style="border:0px;"><img src="components/com_comprofiler/images/smcblogo.gif" /></a><br />';
					}
					?>
					</td>
				</tr>
				<tr>
					<td style="text-align:center" colspan="2">
					<b>
					Copyright 2004 - 2006 MamboJoe/JoomlaJoe, Beat and CB team. This component is released under the GNU/GPL License and a free Community Builder License. All copyright statements must be kept. Derivate work must prominently duly acknowledge original work and include visible online links. Official site:<br /><a href="http://www.joomlapolis.com">www.joomlapolis.com</a>
					<br /><br />
					Credits:
					</b>
					<br />
					</td>
				</tr>
				<tr>
					<td style="text-align:center" colspan="2">
					<script language="JavaScript1.2" type="text/javascript"><!--//--><![CDATA[//><!--
					/*
					Fading Scroller- By DynamicDrive.com
					For full source code, and usage terms, visit http://www.dynamicdrive.com
					This notice MUST stay intact for use
					fcontent[4]="<h3>damian caynes<br />inspired digital<br /></h3>Logo Design";
					*/
					var delay=1000 //set delay between message change (in miliseconds)
					var fcontent=new Array()
					begintag='' //set opening tag, such as font declarations
					fcontent[0]="<h3>JoomlaJoe/MamboJoe<br /></h3>Founder &amp; First Developer";
					fcontent[1]="<h3>DJTrail<br /></h3>Co-Founder &amp; Lead Tester";
					fcontent[2]="<h3>Nick A.<br /></h3>Documentation and Public Relations";
					fcontent[3]="<h3>Beat B.<br /></h3>Lead Developer";
					fcontent[4]="<h3>Lou Griffith<br />Spottsfield Entertainment<br /></h3>Logo Design";
					closetag=''
					
					var fwidth='100%'	//'250px' //set scroller width
					var fheight='80px' //set scroller height
					
					var fadescheme=0 //set 0 to fade text color from (white to black), 1 for (black to white)
					var fadelinks=1 //should links inside scroller content also fade like text? 0 for no, 1 for yes.
					
					///No need to edit below this line/////////////////
					
					var hex=(fadescheme==0)? 255 : 0
					var startcolor=(fadescheme==0)? "rgb(255,255,255)" : "rgb(0,0,0)"
					var endcolor=(fadescheme==0)? "rgb(0,0,0)" : "rgb(255,255,255)"
					
					var ie4=document.all&&!document.getElementById
					var ns4=document.layers
					var DOM2=document.getElementById
					var faderdelay=0
					var index=0
					
					if (DOM2)
					faderdelay=2000
					
					//function to change content
					function changecontent(){
						if (index>=fcontent.length)
							index=0
							if (DOM2){
								document.getElementById("fscroller").style.color=startcolor
								document.getElementById("fscroller").innerHTML=begintag+fcontent[index]+closetag
								linksobj=document.getElementById("fscroller").getElementsByTagName("A")
								if (fadelinks)
									linkcolorchange(linksobj)
									colorfade()
								} else if (ie4)
									document.all.fscroller.innerHTML=begintag+fcontent[index]+closetag
								else if (ns4){
								document.fscrollerns.document.fscrollerns_sub.document.write(begintag+fcontent[index]+closetag)
								document.fscrollerns.document.fscrollerns_sub.document.close()
							}
						index++
						setTimeout("changecontent()",delay+faderdelay)
					}
					
					// colorfade() partially by Marcio Galli for Netscape Communications.  ////////////
					// Modified by Dynamicdrive.com
					
					frame=20;
					
					function linkcolorchange(obj){
						if (obj.length>0){
							for (i=0;i<obj.length;i++)
								obj[i].style.color="rgb("+hex+","+hex+","+hex+")"
							}
						}
					
					function colorfade() {
					// 20 frames fading process
					if(frame>0) {
						hex=(fadescheme==0)? hex-12 : hex+12 // increase or decrease color value depd on fadescheme
						document.getElementById("fscroller").style.color="rgb("+hex+","+hex+","+hex+")"; // Set color value.
						if (fadelinks)
							linkcolorchange(linksobj)
							frame--;
							setTimeout("colorfade()",20);
						} else {
							document.getElementById("fscroller").style.color=endcolor;
							frame=20;
							hex=(fadescheme==0)? 255 : 0
						}
					}
					
					if (ie4||DOM2)
						document.write('<div id="fscroller" style="border:0px solid black;width:'+fwidth+';height:'+fheight+';padding:2px"></div>')
						window.onload=changecontent
					//--><!]]></script>
					<ilayer id="fscrollerns" width="&{fwidth};" height="&{fheight};">
						<layer id="fscrollerns_sub" width="&{fwidth};" height="&{fheight};" left=0 top=0></layer>
					</ilayer>
					</td>
				</tr>
				<tr>
					<td style="text-align:center" colspan="2">If you like the services provided by this free component, please consider making a small donation to support the team behind it:<br />&nbsp;</td>
				</tr>
				<tr>
					<td style="text-align:center">				
						<form action="https://www.paypal.com/cgi-bin/webscr" target="_blank" method="post">
							<input type="hidden" name="cmd" value="_xclick" />
							<input type="hidden" name="business" value="cb.team@joomlapolis.com" />
							<input type="hidden" name="item_name" value="Community Builder <?php echo $ueConfig['version'];?> Donation. Amount in Euros (EUR):" />
							<input type="hidden" name="item_number" value="0001" />
							<input type="hidden" name="no_note" value="1" />
							<input type="hidden" name="currency_code" value="EUR" />
							<input type="hidden" name="tax" value="0" />
							<input class="button" type="submit" value="Donate in EUR to CB.Team@joomlapolis.com" />
						</form>
					</td>
				</tr>
				<tr>
					<td style="text-align:center">				
						<form action="https://www.paypal.com/cgi-bin/webscr" target="_blank" method="post">
							<input type="hidden" name="cmd" value="_xclick" />
							<input type="hidden" name="business" value="cb.team@joomlapolis.com" />
							<input type="hidden" name="item_name" value="Community Builder <?php echo $ueConfig['version'];?> Donation. Amount in US Dollars (USD):" />
							<input type="hidden" name="item_number" value="0001" />
							<input type="hidden" name="no_note" value="1" />
							<input type="hidden" name="currency_code" value="USD" />
							<input type="hidden" name="tax" value="0" />
							<input class="button" type="submit" value="Donate in USD to CB.Team@joomlapolis.com" />
						</form>
					</td>
				</tr>
				</table>
		<br />Community Builder includes following components:<br />
		<table class="adminform" cellpadding="0" cellspacing="0" style="border:0; width:100%; text-align:left;">
		<tr>
			<th>
			Application
			</th>
			<?php
			if ($ui==2) {
			?><th>
			Version
			</th>
			<?php
			}
			?><th>
			License
			</th>
		</tr>
		<tr>
			<td>
			<a href="http://www.foood.net" target="_blank">Icons</a>
			</td>
			<?php
			if ($ui==2) {
			?><td>
			N/A
			</td>
			<?php
			}
			?><td>
			<a href="http://www.foood.net/agreement.htm" target="_blank">
			http://www.foood.net/agreement.htm
			</a>
			</td>
		</tr>
		<tr>
			<td>
			<a href="http://webfx.eae.net" target="_blank">Tabs</a>
			</td>
			<?php
			if ($ui==2) {
			?><td>
			1.02
			</td>
			<?php
			}
			?><td>
			<a href="http://webfx.eae.net/license.html" target="_blank">
			http://webfx.eae.net/license.html
			</a>
			</td>
		</tr>
		<tr>
			<td>
			<a href="http://www.dynarch.com/projects/calendar" target="_blank">Calendar</a>
			</td>
			<?php
			if ($ui==2) {
			?><td>
			1.1
			</td>
			<?php
			}
			?><td>
			<a href="http://www.gnu.org/licenses/lgpl.html" target="_blank">
			GNU Lesser General Public License
			</a>
			</td>
		</tr>
		<tr>
			<td>
			<a href="http://www.bosrup.com/web/overlib/" target="_blank">overLib</a>
			</td>
			<?php
			if ($ui==2) {
			?><td>
			4.17
			</td>
			<?php
			}
			?><td>
			<a href="http://www.bosrup.com/web/overlib/?License" target="_blank">
			http://www.bosrup.com/web/overlib/?License
			</a>
			</td>
		</tr>
		<tr>
			<td>
			<a href="http://snoopy.sourceforge.net/" target="_blank">Snoopy</a>
			</td>
			<?php
			if ($ui==2) {
			?><td>
			1.2.3
			</td>
			<?php
			}
			?><td>
			<a href="http://www.gnu.org/licenses/lgpl.html" target="_blank">
			GNU Lesser General Public License
			</a>
			</td>
		</tr>
		<tr>
			<td>
			<a href="http://www.joomlapolis.com/" target="_blank">BestMenus</a>
			</td>
			<?php
			if ($ui==2) {
			?><td>
			1.0
			</td>
			<?php
			}
			?><td>
			<a href="http://www.joomlapolis.com/" target="_blank">
			Limited Community Builder JoomlaPolis License
			</a>
			</td>
		</tr>
		</table>
			</td>
		</tr>
</table>
<?php
}	
/**
* records the hit to a user profile
* @access private
* @param int viewed user id
*/
function _incHits($profileId) {
	global $database;
	$database->setQuery("UPDATE #__comprofiler SET hits=(hits+1) WHERE id='".$profileId."'");
	if (!$database->query()) {
		echo "<script type=\"text/javascript\"> alert('UpdateHits: ".$database->getErrorMsg()."');</script>\n";
		// exit();
	}
}
/**
* records a visit and the hit with timed protection similar to voting protections
* @param int viewing user id
* @param int viewed user id
* @param IP address of viewing user
*/
function recordViewHit ( $viewerId, $profileId, $currip) {
	global $database, $ueConfig;

	$query = "SELECT * FROM #__comprofiler_views WHERE viewer_id = $viewerId AND profile_id = $profileId";
	if ($viewerId == 0) $query .= " AND lastip = '$currip'";
	$database->setQuery( $query );
	$views = null;
	if ( !( $database->loadObject( $views ) ) ) {
		$query = "INSERT INTO #__comprofiler_views ( viewer_id, profile_id, lastip, lastview, viewscount )"
		. "\n VALUES ( $viewerId, $profileId, '$currip', NOW(), 1 )";
		$database->setQuery( $query );
		if (!$database->query()) {
			echo "<script type=\"text/javascript\"> alert('InsertViews: ".$database->getErrorMsg()."');</script>\n";
			// exit();
		}
		_incHits($profileId);
	} else {
		$lastview = strtotime($views->lastview);
		if ($currip != $views->lastip || time() - $lastview > $ueConfig['minHitsInterval']*60) {
			$query = "UPDATE #__comprofiler_views"
			. "\n SET viewscount = (viewscount+1),"
			. "\n lastview = NOW(),"
			. "\n lastip = '$currip'"
			. "\n WHERE viewer_id = $viewerId AND profile_id = $profileId";
			if ($viewerId == 0) $query .= " AND lastip = '$currip'";
			$database->setQuery( $query );
			if (!$database->query()) {
				echo "<script type=\"text/javascript\"> alert('UpdateViews: ".$database->getErrorMsg()."');</script>\n";
				// exit();
			}
			_incHits($profileId);
		// } else {
		//	echo "ALREADY_HIT!!!";
		}
	}
}

/**
* a function that does a string based find and replace that is case insensitive.
* @param string value to look for
* @param string value to replace with
* @param string text to be searched
* @return string with text searched and replaced
*/
function cbstr_ireplace($search,$replace,$subject) { 
	if(function_exists('str_ireplace')) return str_ireplace($search,$replace,$subject);
    $srchlen=strlen($search);    // lenght of searched string 
     
    while ($find = stristr($subject,$search)) {    // find $search text in $subject - case insensitiv 
        $srchtxt = substr($find,0,$srchlen);    // get new search text  
        $subject = str_replace($srchtxt,$replace,$subject);    // replace founded case insensitive search text with $replace 
    } 
    return $subject; 
} 

/**
* Calendars for date fields handler
* @package Community Builder
* @author Beat
*/
class cbCalendars {
	/**	@var int 1=Front End 2=Admin */
	var $ui=0;
	/** @var string Date Format */
    var $dateFormat;

	/**
	* Constructor
	* Includes files needed for displaying calendar for date fields
	* @param int user interface: 1=Front End 2=Admin
	*/
	function cbCalendars($ui) {
		global $mosConfig_live_site, $mainframe, $mosConfig_lang, $ueConfig;
		$this->ui=$ui;
		$dFind=array("d","m","y","Y");
		$dReplace=array("%d","%m","%y","%Y");
		$this->dateFormat = str_replace($dFind, $dReplace, $ueConfig['date_format']);

		$UElanguagePath=$mainframe->getCfg( 'absolute_path' ).'/components/com_comprofiler/plugin/language';
		if (file_exists($UElanguagePath.'/'.$mosConfig_lang.'/calendar-locals.js')) {
			$calendarLangFile = $mosConfig_live_site.'/components/com_comprofiler/plugin/language/'.$mosConfig_lang.'/calendar-locals.js';
		} else {
			$calendarLangFile = $mosConfig_live_site.'/components/com_comprofiler/plugin/language/default_language/calendar-locals.js';
		}
		addCbHeadTag($ui,'<link rel="stylesheet" type="text/css" media="all" href="'.selectTemplate($ui).'calendar.css" title="win2k-cold-1" />'
		."\n".'<script type="text/javascript" src="'. $mosConfig_live_site . '/components/com_comprofiler/js/calendar.js"></script>'."\n"
		.'<script type="text/javascript" src="'. $calendarLangFile . '"></script>'."\n"		// language
		.'<script type="text/javascript" src="'. $mosConfig_live_site . '/components/com_comprofiler/js/calendar-setup.js"></script>'."\n");
	}

	/**
	* echos a calendar field
	* @param string the field name
	* @param string the field label
	* @param boolean true if field is required
	* @param string the existing value (in Y-mm-dd SQL format)
	* @param boolean read-only field
	*/
	function cbAddCalendar($oName, $oLabel, $oReq, $oValue="", $oReadOnly=false) {
		global $ueConfig;
		if ($oValue=='0000-00-00 00:00:00' || $oValue=='0000-00-00') $oValue="";
		else $oValue=dateConverter($oValue,'Y-m-d',$ueConfig['date_format']);
		$vardisabled = ($oReadOnly) ? ' disabled="disabled"' : '';
		$return = '<input class="inputbox"'.$vardisabled.' mosReq="'.$oReq.'" mosLabel="'.getLangDefinition($oLabel).'" type="text" name="' . $oName .'" readonly="readonly" id="' . $oName . '" value="' . $oValue . '" />'."\n";
		if (!$oReadOnly) $return .= "<script type=\"text/javascript\">\n"
		. "Calendar.setup({"
		. 'inputField : "'.$oName.'",'	// id of the input field
		. 'ifFormat   : "'.$this->dateFormat.'",'	// format of the input field
		. 'showsTime  : false,'				// will display a time selector
		. 'singleClick: true'				// single-click mode
		. "});\n"
		. "</script>\n";
		return $return;
	}
}	// end Class cbCalendars


/**
* Tab Creation handler
* @package Mambo
* @author Phil Taylor
* @author Extended by MamboJoe
*/
class cbTabs extends cbTabHandler {
	/** @var int Use cookies */
	var $useCookies = 0;
	/** @var int 1=Front End 2=Admin */
	var $ui=0;
	/**	@var int 1=Display 2=Edit */
	var $action=0;
	/** @var string adds additional validation javascript for edit tabs */
	var $fieldJS="";
	/**	@var cbCalendars object for displaying calendars */
	var $calendars=null;
	/**	@var array of tab objects for displaying */
	var $tabsToDisplay=null;

	/**
	* Constructor
	* Includes files needed for displaying tabs and sets cookie options
	* @param int useCookies, if set to 1 cookie will hold last used tab between page refreshes
	* @param int ui user interface: 1: frontend, 2: backend
	* @param cbCalendar object reference
	* @param boolean: TRUE (DEFAULT): output scripts for tabpanes, FALSE: silent, no echo output
	*/
	function cbTabs($useCookies, $ui, $calendars=null, $outputTabpaneScript=true) {
		global $mosConfig_live_site;

		$this->cbTabHandler();
		$this->ui=$ui;
		$this->useCookies = $useCookies;
		$this->calendars = $calendars;
		if ($outputTabpaneScript) {
			echo "<script type=\"text/javascript\" src=\"". $mosConfig_live_site . "/components/com_comprofiler/js/tabpane.js\"></script>";
		}
	}

	/**
	* creates a tab pane and creates JS obj
	* @param string The Tab Pane Name
	*/
	function startPane($id){
		$return = "<div class=\"tab-pane\" id=\"".$id."\">";
		$return .= "<script type=\"text/javascript\">\n";
		$return .= "   var tabPane".$id." = new WebFXTabPane( document.getElementById( \"".$id."\" ), ".$this->useCookies." )\n";
		$return .= "</script>\n";
		return $return;
	}

	/**
	* Ends Tab Pane
	*/
	function endPane() {
		$return =  "</div>";
		return $return;
	}

	/**
	* Creates a tab with title text and starts that tabs page
	* @param pID - This is the pane unique identifier
	* @param tabText - This is what is displayed on the tab
	* @param paneid - This is the parent pane to build this tab on
	*/
	function startTab( $pID, $tabText, $paneid ) {
		$return = "<div class=\"tab-page\" id=\"cbtab".$paneid."\">";
		$return .= "<h2 class=\"tab\">".$tabText."</h2>";
		$return .= "<script type=\"text/javascript\">\n";
		$return .= "  tabPane".$pID.".addTabPage( document.getElementById( \"cbtab".$paneid."\" ) );";
		$return .= "</script>";
		return $return;
	}

	/**
	* Ends a tab page
	*/
	function endTab() {
		$return =  "</div>";
		return $return;
	}
	/**
	* Loads tabs list from database (if not already loaded)
	* @access private
	* @param object cb user object to display
	* @param string name of position if only one position to display (default: null)
	* @return array of object tabs from #__comprofiler_tabs database (ordered by position, ordering)
	*/	
	function _loadTabsList($user, $position=null) {
		global $database;
		if ($this->tabsToDisplay === null) {
			$database->setQuery( "SELECT * FROM #__comprofiler_tabs t"
			. "\n WHERE t.enabled=1"
			. ($position==null ? "" : "\n AND t.position='".$position)
			. "\n ORDER BY t.position, t.ordering" );
			$this->tabsToDisplay = $database->loadObjectList();
		}
	}
	/**
	* Gets html code for all cb tabs, sorted by position (default: all, no position name in db means "cb_tabmain")
	* @param object cb user object to display
	* @param string name of position if only one position to display (default: null)
	* @return array of string with html to display at each position, key = position name
	*/	
	function getViewTabs($user, $position=null) {
		global $mosConfig_live_site, $database, $ueConfig, $_CB_OneTwoRowsStyleToggle;
		$html=array();
		$results=array();
		$oNest=array();
		$i=0;
		$tabNavJS=array();
		$tabOneTwoRowsStyleToggle=array();
		$this->action=1;

		$this->_loadTabsList($user, $position);
		
		if (!is_array($this->tabsToDisplay)) {
			return null;
		}
		//Pass 1: gets all menu and status content
		$oContent=array();
		foreach($this->tabsToDisplay AS $k => $oTab) {
			if($oTab->pluginclass!=null) {
				$this->_callTabPlugin($oTab, $user, $oTab->pluginclass, 'getMenuAndStatus', $oTab->pluginid);
			}
		}
		//Pass 2: generate content
		$oContent=array();
		foreach($this->tabsToDisplay AS $k => $oTab) {
			if (isset($oTab->position) && ($oTab->position != "")) $pos=$oTab->position; else $pos="cb_tabmain";
			if (!isset($tabOneTwoRowsStyleToggle[$pos])) $tabOneTwoRowsStyleToggle[$pos] = 1;
			
			$oContent[$k] = "";
			if($oTab->pluginclass!=null) {
				$_CB_OneTwoRowsStyleToggle = $tabOneTwoRowsStyleToggle[$pos];
				$oContent[$k] .= $this->_callTabPlugin($oTab, $user, $oTab->pluginclass, 'getDisplayTab', $oTab->pluginid);
				$tabOneTwoRowsStyleToggle[$pos] = $_CB_OneTwoRowsStyleToggle;
			}
		}
		foreach($this->tabsToDisplay AS $k => $oTab) {
			if (isset($oTab->position) && ($oTab->position != "")) $pos=$oTab->position; else $pos="cb_tabmain";
			if($oTab->fields) {
				$_CB_OneTwoRowsStyleToggle = $tabOneTwoRowsStyleToggle[$pos];
				$oContent[$k] .= $this->_getViewTabContents($oTab->tabid,$user);
				$tabOneTwoRowsStyleToggle[$pos] = $_CB_OneTwoRowsStyleToggle;
			}
		}
		//Pass 3: generate formatted output for each position by display type (keeping tabs together in each position)
		foreach($this->tabsToDisplay AS $k => $oTab) {
			if (isset($oTab->position) && ($oTab->position != "")) $pos=$oTab->position; else $pos="cb_tabmain";
			if(!isset($html[$pos])) {
				$html[$pos]="";
				$results[$pos]="";
				$oNest[$pos]="";
				$tabNavJS[$pos]=array();
			}
			if($oContent[$k]!="") {
				$overlaysWidth ="400";						//BB later this could be one more tab parameter...
				switch ($oTab->displaytype) {
					case "html":
						$html[$pos] .= $oContent[$k];
						break;
					case "div":
						$html[$pos] .= "\n\t\t\t<div style=\"width:95%\" class=\"contentheading\">"		// id=\"".$oTab->???."\
									.getLangDefinition($oTab->title)."</div>"
									.  "\n\t\t\t<div class=\"contentpaneopen\" style=\"width:95%\">".$oContent[$k]."</div>";
						break;
					case "overlib":
						$tipTitle = $htmltext = getLangDefinition($oTab->title);
						$fieldTip = "&lt;div class=\"contentpaneopen\" style=\"width:100%\"&gt;".$oContent[$k]."&lt;/div&gt;";
						$style = "class=\"cb-tips-hover\"";
						$olparams = "";
						$html[$pos] .= cbFieldTip($this->ui, $fieldTip, $tipTitle, $overlaysWidth, '', $htmltext, "", $style, $olparams,false);
						break;
					case "overlibfix":
						$tipTitle = $htmltext = getLangDefinition($oTab->title);
						$fieldTip = "&lt;div class=\"contentpaneopen\" style=\"width:100%\"&gt;".$oContent[$k]."&lt;/div&gt;";
						$style = "class=\"cb-tips-hover\"";
						$olparams = "STICKY,NOCLOSE,CLOSETEXT,'"._UE_CLOSE_OVERLIB."'";
						$html[$pos] .= cbFieldTip($this->ui, $fieldTip, $tipTitle, $overlaysWidth, '', $htmltext, "", $style, $olparams,false);
						break;
					case "overlibsticky":
						$tipTitle = $htmltext = getLangDefinition($oTab->title);
						$href = "javascript:void(0)";
						$fieldTip = "&lt;div class=\"contentpaneopen\" style=\"width:100%\"&gt;".$oContent[$k]."&lt;/div&gt;";
						$style = "class=\"cb-tips-button\" title=\""._UE_CLICKTOVIEW." ".$tipTitle."\"";
						$olparams = "STICKY,CLOSECLICK,CLOSETEXT,'"._UE_CLOSE_OVERLIB."'";
						$html[$pos] .= cbFieldTip($this->ui, $fieldTip, $tipTitle, $overlaysWidth, '', $htmltext, $href, $style, $olparams,true);
						break;
					case "tab":
					default:
						//$results .= $this->startPane($pos);	done at the end below
						if($ueConfig['nesttabs'] && $oTab->fields) {
							$oNest[$pos] .= $this->startTab("CBNest".$pos,getLangDefinition($oTab->title),$oTab->tabid)
									. "\n\t\t\t<div class=\"tab-content\">"
									. $oContent[$k]
									. "</div>\n"
									. $this->endTab();
							$tabNavJS[$pos][$i]->nested = true;
						} else {
							$results[$pos] .= $this->startTab($pos,getLangDefinition($oTab->title),$oTab->tabid)
									. "\n\t\t\t<div class=\"tab-content\">"
									. $oContent[$k]
									. "</div>\n"
									. $this->endTab();
							$tabNavJS[$pos][$i]->nested = false;
						}
						$tabNavJS[$pos][$i]->name = getLangDefinition($oTab->title);
						$tabNavJS[$pos][$i]->id = $oTab->tabid;
						$tabNavJS[$pos][$i]->pluginclass = $oTab->pluginclass;
						$i++;
						break;
				}
			}
		}	//foreach tab
		// Pass 4: concat different types, generating tabs preambles/postambles:
		foreach ($html as $pos => $val) {
			if($ueConfig['nesttabs'] && $oNest[$pos]) {
				$oNestPre = $this->startTab($pos,_UE_PROFILETAB,0)
						  . "<div style=\"width:97%; margin:13px 1% 13px 1%;\">"
						  . $this->startPane("CBNest".$pos);
				$oNest[$pos] .= $this->endPane()
							 . "</div>"
							 . $this->endTab();
				$results[$pos] = $oNestPre.$oNest[$pos].$results[$pos];
			}
			if ($results[$pos]) {
				if ($val) $html[$pos] .= "<br />";
				$html[$pos] .= $this->_getTabNavJS($pos, $tabNavJS[$pos])
							. $this->startPane($pos)
							. $results[$pos]
							. $this->endPane();
			}
		}
		return $html;
	}

	function _getViewTabContents($tabid,$user) {
		global $ueConfig,$database,$_CB_OneTwoRowsStyleToggle;
	$return="";
	$results="";
	$whereAdd=""; 
	IF ($ueConfig['allow_email_display']==0) $whereAdd = " AND f.type != 'emailaddress' ";
	$database->setQuery( "SELECT * FROM #__comprofiler_fields f"
	. "\n WHERE f.published=1 AND f.profile=1 AND f.tabid = ".$tabid." "
	. $whereAdd
	. "\n ORDER BY f.ordering" );
	$oFields = $database->loadObjectList();
	
	if (is_array($oFields)) foreach($oFields AS $oField) {
		$fValue='$user->'.$oField->name;
		eval("\$fValue = \"".$fValue."\";");
		$oValue = getFieldValue($oField->type, /* stripslashes */ ($fValue),$user);
		if($oValue!=null || trim($oValue)!='' || $oField->type == 'delimiter') {
			$class = "sectiontableentry".$_CB_OneTwoRowsStyleToggle;
			$_CB_OneTwoRowsStyleToggle = ($_CB_OneTwoRowsStyleToggle == 1 ? 2 : 1);
			$results .= "\n\t\t\t\t<tr class=\"".$class."\">";
			$colspan=2;
			if($oField->type != 'delimiter') {
				if(getLangDefinition($oField->title)!="") {
					$results .= "\n\t\t\t\t\t<td class=\"titleCell\""
					. ( ($this->ui==2) ? " style=\"font-weight:bold;width:40%;\"" : "" )
					.">". getLangDefinition($oField->title) .":</td>";
					$colspan=1;
				}
				$results .= "\n\t\t\t\t\t<td colspan=\"".$colspan."\" class=\"fieldCell\">".$oValue."</td>";
				$results .= "\n\t\t\t\t</tr>";
			} else {
				$results .= "\n\t\t\t\t\t<td colspan=\"".$colspan."\" class=\"delimiterCell\">". unHtmlspecialchars(getLangDefinition($oField->title)) ."</td>";
				$results .= "\n\t\t\t\t</tr>";
				if ($oField->description) {
					$results .= "\n\t\t\t\t<tr class=\"".$class."\">\n\t\t\t\t\t<td colspan=\"".$colspan."\" class=\"descriptionCell\">". unHtmlspecialchars(getLangDefinition($oField->description)) ."</td>\n";
					$results .= "\n\t\t\t\t</tr>";
				}
			}
		}
	}
	if($results!="") {
		$return = "\n\t\t\t<table class=\"cbFields\" cellpadding=\"0\" cellspacing=\"0\" style=\"width:95%\">";
		$return .= $results;
		$return .= "\n\t\t\t</table>";
	}
	return $return;
}

	function _callTabPlugin($tab, &$user, $pluginclass, $method, $pluginid=null, $postdata=null) {
		global $_PLUGINS;
		$results=null;
        if ( $pluginid ) {
	        if($_PLUGINS->loadPluginGroup('user',array($pluginid))) {
	        	$args=array($tab , &$user, $this->ui);
	        	if ($postdata !== null) $args[]=$postdata;
	        	$results=$_PLUGINS->call($pluginid,$method,$pluginclass, $args, $tab->params);
	        }
        }
	    return $results;
	}
	function _getVarPlugin($tab, $pluginclass, $variable, $pluginid=null) {
		global $_PLUGINS;
		return $_PLUGINS->getVar($pluginid,$pluginclass, $variable);
	}

	function getEditTabs($user) {
	global $database;
	$i=0;
	$tabNavJS=array();
	$this->action=2;
	$this->fieldJS="";
	$results="";
	$database->setQuery( "SELECT * FROM #__comprofiler_tabs t"
	. "\n WHERE t.enabled=1 "
	. "\n ORDER BY t.position, t.ordering" );
	$oTabs = $database->loadObjectList();
	foreach($oTabs AS $oTab) {
		$oPContent="";
		$oFContent="";
		$oContent="";
 		if($oTab->pluginclass!=null) {
			$oPContent = $this->_callTabPlugin($oTab, $user, $oTab->pluginclass, 'getEditTab', $oTab->pluginid);
			$this->fieldJS .= $this->_getVarPlugin($oTab, $oTab->pluginclass, 'fieldJS', $oTab->pluginid);
		} 
		if($oTab->fields) {
			if($oTab->pluginclass!=null) $oTab->description=null;
			$oFContent = $this->_getEditTabContents($oTab,$user);
		}
		if($oPContent!="") $oContent .= $oPContent;
		if($oFContent!="") $oContent .= $oFContent;
		if($oContent!="") {
			$results .= $this->startTab("CB",getLangDefinition($oTab->title),$oTab->tabid);
			$results .= "\n\t\t\t<table cellpadding=\"5\" cellspacing=\"0\" border=\"0\" width=\"95%\"><tr><td>";
			$results .= $oContent;
			$results .= "\n\t</td></tr></table>";
			$results .= $this->endTab();
			$tabNavJS[$i]->nested = false;
			$tabNavJS[$i]->name = getLangDefinition($oTab->title);
			$tabNavJS[$i]->id = $oTab->tabid;
			$tabNavJS[$i]->pluginclass = $oTab->pluginclass;
			$i++;
			}
	}
	$return = $this->_getTabNavJS("CB", $tabNavJS);
	$return .= $this->startPane("CB");
	$return .= $results;
	$return .= $this->endPane();
	
	return $return;
	}
	function _getEditTabContents($tab,$user) {
		global $database,$ueConfig;
	$results="";
	$return="";
	$database->setQuery( "SELECT f.* FROM #__comprofiler_fields f"
	. "\n WHERE f.published=1 AND f.tabid=".$tab->tabid." ORDER BY f.ordering");
	$rowFields = $database->loadObjectList();
	$rowFieldValues=array();
	$fieldJS='';
	if(count($rowFields)>0) {
	if($tab->description != null) $results .= "\t<div class=\"tab_Description\">".unHtmlspecialchars(getLangDefinition($tab->description))."</div>\n";
	$results .= "\t<table cellpadding=\"5\" cellspacing=\"0\" border=\"0\" width=\"100%\">\n";
	foreach($rowFields AS $rowField) {
		$k = "\$user->".$rowField->name;
		eval("\$k = \"$k\";");
		if($rowField->type=='editorta') {
			ob_start();
			getEditorContents( 'editor'.$rowField->name, $rowField->name ) ;
			$fieldJS .= ob_get_contents();
			ob_end_clean();
		}
		$database->setQuery( "SELECT fieldtitle, fieldid AS id FROM #__comprofiler_field_values"	//BB: is id needed ? breaks xhtml W3C
		. "\n WHERE fieldid = ".$rowField->fieldid
		. "\n ORDER BY ordering" );
		$Values = $database->loadObjectList();
		$adminReq=$rowField->required;
		if($this->ui==2) {
			$rowField->readonly=0;
			if($ueConfig['adminrequiredfields']==0) $adminReq=0;
		}
		$multi=null;
		$disabled=null;
		if($rowField->type=='multiselect') $multi="multiple='multiple'";
		if($rowField->readonly==1) {
			$disabled = "disabled=\"disabled\"";
			$adminReq = "0";
		}
		if(count($Values) > 0) {
			if($rowField->type=='radio') $rowFieldValues['lst_'.$rowField->name] = moscomprofilerHTML::radioListTable( $Values, $rowField->name, 'class="inputbox" '.$disabled.' size="1" mosReq="'.$adminReq.'" mosLabel="'.getLangDefinition($rowField->title).'"', 'fieldtitle', 'fieldtitle', $k, $rowField->cols, $rowField->rows, $rowField->size);		//BB missing ", $adminReq" here and elsewehre???
			else {
				$ks=explode("|*|",$k);
				$k = array();
				foreach($ks as $kv) {
					$k[]->fieldtitle=$kv;
				}
				if($rowField->type=='multicheckbox') $rowFieldValues['lst_'.$rowField->name] = moscomprofilerHTML::checkboxListTable( $Values, $rowField->name."[]", 'class="inputbox" '.$disabled.' size="'.$rowField->size.'" '.$multi.' mosLabel="'.getLangDefinition($rowField->title).'"', 'fieldtitle', 'fieldtitle', $k, $rowField->cols, $rowField->rows, $rowField->size, $adminReq);
				else $rowFieldValues['lst_'.$rowField->name] = moscomprofilerHTML::selectList( $Values, $rowField->name."[]", 'class="inputbox" '.$disabled.' size="'.$rowField->size.'" '.$multi.' mosReq="'.$adminReq.'" mosLabel="'.getLangDefinition($rowField->title).'"', 'fieldtitle', 'fieldtitle', $k);
			}
		}
		$fieldValueList="";
		$fieldIDValue="";
		$results .= "\t\t<tr>\n";
		$colspan=2;
		if($rowField->type=='delimiter') {
			$results .= "\t\t\t<td colspan=\"".$colspan."\" class=\"delimiterCell\">". unHtmlspecialchars(getLangDefinition($rowField->title)) ."</td>\n";
			if ($rowField->description) $results .= "\t\t</tr>\n\t\t<tr>\n\t\t\t<td colspan=\"".$colspan."\" class=\"descriptionCell\">". unHtmlspecialchars(getLangDefinition($rowField->description)) ."</td>\n";
		} else {
			if(getLangDefinition($rowField->title)!="") {
				$results .= "\t\t\t<td class=\"titleCell\">". getLangDefinition($rowField->title) .":</td>\n";
				$colspan=1;
			}
			if(ISSET($rowFieldValues['lst_'.$rowField->name])) $fieldValueList=$rowFieldValues['lst_'.$rowField->name];
			if(ISSET($rowField->id)) $fieldIDValue=$rowField->id;
			$results .= "\t\t\t<td colspan=\"".$colspan."\" class=\"fieldCell\">".getFieldEntry($this->ui,$this->calendars,$rowField->type,$rowField->name,$rowField->description,$rowField->title,$k,$adminReq,$rowField->title,$fieldIDValue,$rowField->size, $rowField->maxlength, $rowField->cols, $rowField->rows,$rowField->profile,$fieldValueList,$rowField->readonly)."</td>\n";
		}
		$results .= "\t\t</tr>\n";
	}
	$results.="\t</table>\n";
	$this->fieldJS .=$fieldJS;
	$return.=$results;
	}
	return $return;
	}

	function _getTabNavJS($pID, $tabs) {
		global $ueConfig;
		
		$i=0;
		$i_nest=0;
		$nested=false;
		if(!count($tabs)>0) {
			return "";
		}
		$return="<script type=\"text/javascript\">\n";
		$return.="var tabPane".$pID.";\n";
		if ($ueConfig["nesttabs"]) $return.="var tabPaneCBNest".$pID.";\n";
		$return.="function showCBTab( sName ) {\n";
		$return.="if (typeof tabPane".$pID." != \"undefined\" ) {\n";
		$return.="switch ( sName.toLowerCase() ) {\n";
		foreach($tabs AS $tab) {
			if ($nested && !$tab->nested) $i++;
			$return.="	case \"".strtolower($tab->name)."\":\n";
			$return.="	case \"".$tab->id."\":\n";
			if($tab->pluginclass!=null) $return.="	case \"".strtolower($tab->pluginclass)."\":\n";
			$return.="		tabPane".$pID.".setSelectedIndex( ".$i." );\n";
			if ($tab->nested)	$return.="		tabPaneCBNest".$pID.".setSelectedIndex( ".$i_nest." );\n";
			$return.="		break;\n";
			if ($tab->nested) $i_nest++;
			else $i++;
			$nested = $tab->nested;
		}
		$return.="}\n";
		$return.="}\n";
		$return.="}\n";
		$return.="</script>\n";
		return $return;
	}

	function savePluginTabs(&$user, &$postdata) {
		global $database;
		$database->setQuery( "SELECT * FROM #__comprofiler_tabs t"
		. "\n WHERE t.enabled=1 AND t.pluginclass is not null"
		. "\n ORDER BY t.position, t.ordering" );
		$oTabs = $database->loadObjectList();

		foreach($oTabs AS $oTab) {
			if($oTab->pluginclass!=null) {
				$this->_callTabPlugin($oTab, $user, $oTab->pluginclass, 'saveEditTab', $oTab->pluginid, $postdata);
			} 
		}
		return 1;
	}

	function getRegistrationPluginTabs() {
		global $database;
		$results = "";
		$userNull = null;
		$database->setQuery( "SELECT * FROM #__comprofiler_tabs t"
		. "\n WHERE t.enabled=1 AND t.pluginclass is not null"
		. "\n ORDER BY t.position, t.ordering" );
		$oTabs = $database->loadObjectList();

		foreach($oTabs AS $oTab) {
			if($oTab->pluginclass!=null) {
				$results .= $this->_callTabPlugin($oTab, $userNull, $oTab->pluginclass, 'getDisplayRegistration', $oTab->pluginid);
				$this->fieldJS .= $this->_getVarPlugin($oTab, $oTab->pluginclass, 'fieldJS', $oTab->pluginid);
			} 
		}
		return $results;
	}

	function saveRegistrationPluginTabs(&$user, $postdata) {
		global $database;
		$database->setQuery( "SELECT * FROM #__comprofiler_tabs t"
		. "\n WHERE t.enabled=1 AND t.pluginclass is not null"
		. "\n ORDER BY t.position, t.ordering" );
		$oTabs = $database->loadObjectList();
		$results = array();
		foreach($oTabs AS $oTab) {
			if($oTab->pluginclass!=null) {
				$results[] = $this->_callTabPlugin($oTab, $user, $oTab->pluginclass, 'saveRegistrationTab', $oTab->pluginid, $postdata);
			}
		}
		return $results;
	}

	/**
	* Loads plugin corresponding to tab from database and calls a method of it.
	* @param object cb user object to display
	* @param array $_POST data
	* @param string name of class to search for and to call
	* @param string name of method to call
	* @return mixed returned result of call (null if call not performed)
	*/	
	function tabClassPluginTabs($user, $postdata, $tabClassName, $method) {
		global $database, $_PLUGINS;
		
		$database->setQuery( "SELECT * FROM #__comprofiler_tabs t"
		. "\n WHERE t.enabled=1 AND t.pluginclass is not null AND LOWER(t.pluginclass) ='".strtolower(cbGetEscaped($tabClassName))."'");
		$oTabs = $database->loadObjectList();
		$result = null;
		if (count($oTabs)==1) {
			$oTab = $oTabs[0];
			if($oTab->pluginid) {
				if ($_PLUGINS->loadPluginGroup('user', array($oTab->pluginid))) {
					if($oTab->pluginclass!=null) {
						$result = $this->_callTabPlugin($oTab, $user, $oTab->pluginclass, $method, $oTab->pluginid, $postdata);
					}
				}
			}
		}
		return $result;
	}
}	// end Class cbTabs

/**
* PMS handler
* @package Community Builder
* @author Beat
*/
class cbPMS extends cbPMSHandler {
	var $PMSpluginsList;
	/**
	* Constructor
	*/
	function cbPMS() {
		$this->cbPMSHandler();
		$this->PMSpluginsList = null;
	}

	function _callPlugin($plug, $args, $pluginclass, $method) {
		global $_PLUGINS;
		$results=null;
		if ( $plug->id ) {
			if($_PLUGINS->loadPluginGroup('user', array($plug->id))) {
				$results=$_PLUGINS->call($plug->id, $method, $pluginclass, $args, $plug->params);
			}
		}
		return $results;
	}
	function _callPluginTypeMethod($type, $methodName, $args) {
		global $database;
		$results = array();
		if ($this->PMSpluginsList === null) {
			$database->setQuery( "SELECT * FROM #__comprofiler_plugin p"
			. "\n WHERE p.published=1 "
			. "\n AND p.element LIKE '%".$type.".%' "
			. "\n ORDER BY p.ordering" );
			$this->PMSpluginsList = $database->loadObjectList();
		}
		foreach($this->PMSpluginsList AS $plug) {
			$className = 'get'.substr($plug->element, strlen($type)+1).'Tab';
			$results[] = $this->_callPlugin($plug, $args, $className, $methodName);
		}
		return $results;
	}
	/**
	* Sends a PMS message on the enabled "pms.*" plugins
	* @param int userId of receiver
	* @param int userId of sender
	* @param string subject of PMS message (UNESCAPED)
	* @param string body of PMS message (UNESCAPED)
	* @param boolean false: real user-to-user message; true: system-Generated by an action from user $fromid (if non-null)
	* @param boolean false: subject and message body UNESCAPED = default; true: ESCAPED
	* @return boolean : true for OK, or false if ErrorMSG generated. Special error: _UE_PMS_TYPE_UNSUPPORTED : if anonym fromid>=0 sysgenerated unsupported
	*/
	function sendPMSMSG($toid, $fromid, $subject, $message, $systemGenerated=false, $escaped=false) {
		$args = array($toid, $fromid, $subject, $message, $systemGenerated, $escaped);
		return $this->_callPluginTypeMethod("pms", "sendUserPMS", $args);
	}
	/**
	* returns all the parameters needed for a hyperlink or a menu entry to do a pms action
	* @param int userId of receiver
	* @param int userId of sender
	* @param string subject of PMS message
	* @param string body of PMS message
	* @param int kind of link: 1: link to compose new PMS message for $toid user. 2: link to inbox of $fromid user; 3: outbox, 4: trashbox,
	  5: link to edit pms options
	* @return mixed array of string {"caption" => menu-text ,"url" => NON-sefRelToAbs relative url-link, "tooltip" => description} or false and errorMSG
	*/
	function getPMSlinks($toid=0, $fromid=0, $subject="", $message="", $kind) {
		$args = array($toid, $fromid, $subject, $message, $kind);
		return $this->_callPluginTypeMethod("pms", "getPMSlink", $args);
	}
	/**
	* gets PMS system capabilities
	* @return mixed array of string {"subject" => boolean ,"body" => boolean} or false if ErrorMSG generated
	*/
	function getPMScapabilites() {
		$args = array();
		return $this->_callPluginTypeMethod("pms", "getPMScapabilites", $args);
	}
	/**
	* gets PMS unread messages count
	* @param	int user id
	* @return	mixed number of messages unread by user $userid or false if ErrorMSG generated
	*/
	function getPMSunreadCount($userid) {
		$args = array($userid);
		return $this->_callPluginTypeMethod("pms", "getPMSunreadCount", $args);
	}
}	// end Class cbPMS

/**
* Connections Class for handeling CB connections
* @package Community Builder
* @author MamboJoe
*/
class cbConnection {
	/**	@var errorMSG should be used to store the error message when an error is encountered*/
	var $errorMSG;
	/**	@var errorNum should be used to store the error number when an error is encountered*/
	var $errorNum;
	/**	@var referenceid should be used to store the userid related to base user of the connection action*/
	var $referenceid;
	/**	@var connectionid should be used to store the userid related to target user of the connection action*/
	var $connectionid;
	/**	@var degreeOfSep should be used to store the numeric value related to distance between referenceid and connectionid*/
	var $degreeOfSep;
	/**	@var userMSG should be used to store the message that needs to be returned to the user*/
	var $userMSG;
	
	function cbConnection($referenceid) {
		$this->referenceid=$referenceid;
		return;
	}
	function addConnection($connectionid,$umsg=null) {
		global $database,$ueConfig, $mosConfig_live_site, $_PLUGINS;

		$_PLUGINS->loadPluginGroup('user');
		$_PLUGINS->trigger( 'onBeforeAddConnection', array($this->referenceid,$connectionid,$ueConfig['useMutualConnections'],$ueConfig['autoAddConnections'],&$umsg));
		if($_PLUGINS->is_errors()) {
			$this->_setUserMSG($_PLUGINS->getErrorMSG());
			return false;
		}

		if(!$this->_insertConnection($this->referenceid,$connectionid,$umsg)) {	
			$this->_setUserMSG($this->getErrorMSG());
			return false;
		}
		if($ueConfig['useMutualConnections']) {
			$msg = _UE_CONNECTIONPENDINGACCEPTANCE;
			$subject= _UE_CONNECTIONPENDSUB;
			$messageHTML = _UE_CONNECTIONPENDMSG;
		} else {
			$msg = _UE_CONNECTIONADDSUCCESSFULL;
			$subject= _UE_CONNECTIONMADESUB;
			$messageHTML = _UE_CONNECTIONMADEMSG;
		}
		$messageText = $messageHTML;
	
		$result = $this->_notifyConnectionChange($this->referenceid,$connectionid,$msg,$subject,$messageHTML,$messageText,$umsg);
		$_PLUGINS->trigger( 'onAfterAddConnection', array($this->referenceid,$connectionid,$ueConfig['useMutualConnections'],$ueConfig['autoAddConnections']));
		return $result;
	}
	function _notifyConnectionChange($userid,$connectionid,$msg,$subject,$messageHTML,$messageText,$userMessage=null) {
		global $database,$ueConfig,$mosConfig_live_site;
	
		$rowFrom = new mosUser( $database );
		$rowFrom->load( $userid );
	
		$fromname=getNameFormat($rowFrom->name,$rowFrom->username,$ueConfig['name_format']);
		$fromURL=sefRelToAbs("index.php?option=com_comprofiler&amp;task=userProfile&amp;user=".$userid."&amp;tab=1".getCBprofileItemid(true));
		if (strncasecmp("http", $fromURL, 4) != 0) $fromURL = $mosConfig_live_site . "/" . $fromURL;
		$subject= sprintf($subject,$fromname);

		if($userMessage!=null) {
			$messageHTML .= sprintf(str_replace("\n", "\n<br />", _UE_CONNECTIONMSGPREFIX),$fromname,"<strong>".htmlspecialchars($userMessage)."</strong>");
			$messageText .= sprintf(str_replace("\n", "\r\n", _UE_CONNECTIONMSGPREFIX),$fromname,$userMessage);
		}

		$nmsgHTML= sprintf($messageHTML,'<strong><a href="'.$fromURL.'">'.$fromname.'</a></strong>');
		$nmsgText = sprintf($messageText,$fromname);

		$manageURL = sefRelToAbs('index.php?option=com_comprofiler&amp;task=manageConnections'.getCBprofileItemid(true));
		if (strncasecmp("http", $manageURL, 4) != 0) $manageURL = $mosConfig_live_site . "/" . $manageURL;
		$nmsgHTML = $nmsgHTML . "\n<br /><br /><a href=\"".$manageURL."\">"._UE_MANAGECONNECTIONS."</a>\n";
		$nmsgText = $nmsgText . "\r\n\r\n\r\n".$fromname." "._UE_PROFILE.": ".unAmpersand($fromURL);
		$nmsgText = $nmsgText . "\r\n\r\n"._UE_MANAGECONNECTIONS.": ".unAmpersand($manageURL)."\r\n";

		$cbNotification= new cbNotification();
		$cbNotification->sendFromUser($connectionid,$userid,$subject,$nmsgHTML,$nmsgText);
		
		$this->_setUserMSG($msg);
		return true;
	
	}
	function _insertConnection($refid, $connid, $userMessage) {
		global $database,$ueConfig;
		$accepted=1;
		$pending=0;
		if($ueConfig['useMutualConnections']) {
			$accepted=1;
			$pending=1;
		} 
		$sql="INSERT INTO #__comprofiler_members (referenceid,memberid,accepted,pending,membersince,reason) VALUES ('".$database->getEscaped($refid)."','".$database->getEscaped($connid)."',$accepted,$pending,CURDATE(),'".$database->getEscaped($userMessage)."')";
		$database->SetQuery($sql);
		if (!$database->query()) {
			$this->_setErrorMSG("SQL error insCon1 " . $database->stderr(true));
			return false;
		}
		if($ueConfig['autoAddConnections']) {
			$accepted=1;
			$pending=0;
			if($ueConfig['useMutualConnections']) {
				$accepted=0;
				$pending=0;
			}
			$sql="INSERT INTO #__comprofiler_members (referenceid,memberid,accepted,pending,membersince,reason) VALUES ('".$database->getEscaped($connid)."','".$database->getEscaped($refid)."',$accepted,$pending,CURDATE(),'".$database->getEscaped($userMessage)."')";
			$database->SetQuery($sql);
			if (!$database->query()) {
				$this->_setErrorMSG("SQL error insCon2 " . $database->stderr(true));
				return false;
			}
		}
		return true;
	}
	function removeConnection($userid,$connectionid) {
		global $ueConfig, $_PLUGINS;

		if ($this->getConnectionDetails($userid,$connectionid) === false) {
			$this->_setErrorMSG(_UE_NODIRECTCONNECTION);
			return false;
		}
		$_PLUGINS->loadPluginGroup('user');
		$_PLUGINS->trigger( 'onBeforeRemoveConnection', array($userid,$connectionid,$ueConfig['useMutualConnections'],$ueConfig['autoAddConnections']));
		if($_PLUGINS->is_errors()) {
			$this->_setUserMSG($_PLUGINS->getErrorMSG());
			return false;
		}

		$this->_deleteConnection($userid,$connectionid);
		
		$msg = _UE_CONNECTIONREMOVESUCCESSFULL;
		$subject = _UE_CONNECTIONREMOVED_SUB;
		$messageHTML = _UE_CONNECTIONREMOVED_MSG;
		$messageText = $messageHTML;
		$result = $this->_notifyConnectionChange($userid,$connectionid,$msg,$subject,$messageHTML,$messageText);
		$_PLUGINS->trigger( 'onAfterRemoveConnection', array($userid,$connectionid,$ueConfig['useMutualConnections'],$ueConfig['autoAddConnections']));
		return $result;
	}

	function denyConnection($userid,$connectionid) {			//BB needs to be called+do different then remove (one way if ...?)
		global $ueConfig, $_PLUGINS;

		if ($this->getConnectionDetails($userid,$connectionid) === false) {
			$this->_setErrorMSG(_UE_NODIRECTCONNECTION);
			return false;
		}
		$_PLUGINS->loadPluginGroup('user');
		$_PLUGINS->trigger( 'onBeforeDenyConnection', array($userid,$connectionid,$ueConfig['useMutualConnections'],$ueConfig['autoAddConnections']));
		if($_PLUGINS->is_errors()) {
			$this->_setUserMSG($_PLUGINS->getErrorMSG());
			return false;
		}

		$this->_deleteConnection($userid,$connectionid);
		
		$msg = _UE_CONNECTIONDENYSUCCESSFULL;
		$subject = _UE_CONNECTIONDENIED_SUB;
		$messageHTML = _UE_CONNECTIONDENIED_MSG;
		$messageText = $messageHTML;
		$result = $this->_notifyConnectionChange($userid,$connectionid,$msg,$subject,$messageHTML,$messageText);
		$_PLUGINS->trigger( 'onAfterDenyConnection', array($userid,$connectionid,$ueConfig['useMutualConnections'],$ueConfig['autoAddConnections']));
		return $result;
	}
	function _deleteConnection($refid,$connid) {
		global $database,$ueConfig;
		$sql="DELETE FROM #__comprofiler_members WHERE referenceid='".cbGetEscaped($refid)."' AND memberid='".cbGetEscaped($connid)."'";
		$database->SetQuery($sql);
		if (!$database->query()) {
			$this->_setErrorMSG("SQL error" . $database->stderr(true));
			return 0;
		}
		
		if($ueConfig['autoAddConnections']) {
			$sql="DELETE FROM #__comprofiler_members WHERE referenceid='".cbGetEscaped($connid)."' AND memberid='".cbGetEscaped($refid)."'";
			$database->SetQuery($sql);
			if (!$database->query()) {
				$this->_setErrorMSG("SQL error" . $database->stderr(true));
				return 0;
			}
		}
		return 1;
	}

	function acceptConnection($userid,$connectionid) {
		global $ueConfig, $_PLUGINS;

		if ($this->getConnectionDetails($userid,$connectionid) === false) {
			$this->_setErrorMSG(_UE_NODIRECTCONNECTION);
			return false;
		}
		$_PLUGINS->loadPluginGroup('user');
		$_PLUGINS->trigger( 'onBeforeAcceptConnection', array($userid,$connectionid,$ueConfig['useMutualConnections'],$ueConfig['autoAddConnections']));
		if($_PLUGINS->is_errors()) {
			$this->_setUserMSG($_PLUGINS->getErrorMSG());
			return false;
		}
	
		$this->_activateConnection($userid,$connectionid);
		
		$msg = _UE_CONNECTIONACCEPTSUCCESSFULL;
		$subject = _UE_CONNECTIONACCEPTED_SUB;
		$messageHTML = _UE_CONNECTIONACCEPTED_MSG;
		$messageText = $messageHTML;
		$result = $this->_notifyConnectionChange($userid,$connectionid,$msg,$subject,$messageHTML,$messageText);
		$_PLUGINS->trigger( 'onAfterAcceptConnection', array($userid,$connectionid,$ueConfig['useMutualConnections'],$ueConfig['autoAddConnections']));
		return $result;
	}
	function _activateConnection($userid,$connectionid) {
		global $database,$ueConfig;
		$sql="UPDATE #__comprofiler_members SET accepted=1, pending=0, membersince=CURDATE() WHERE referenceid=".cbGetEscaped($connectionid)." AND memberid=".cbGetEscaped($userid);
		$database->SetQuery($sql);
		//echo $database->getQuery();
		if (!$database->query()) {
			$this->_setErrorMSG("SQL error" . $database->stderr(true));
			return 0;
		}
		
		if($ueConfig['autoAddConnections']) {
			$sql="UPDATE #__comprofiler_members SET accepted=1, pending=0, membersince=CURDATE() WHERE referenceid=".cbGetEscaped($userid)." AND memberid=".cbGetEscaped($connectionid);
			$database->SetQuery($sql);
			//echo $database->getQuery();
			if (!$database->query()) {
				$this->_setErrorMSG("SQL error" . $database->stderr(true));
				return 0;
			}
		}
		return 1;
	
	}
	function getPendingConnections($userid) {
		global $database;
		$query = "SELECT DISTINCT m.*,u.name,u.email,u.username,c.avatar,c.avatarapproved, u.id, IF(s.session_id=null,0,1) AS 'isOnline' "
		. "\n FROM #__comprofiler_members AS m"
		. "\n LEFT JOIN #__comprofiler AS c ON m.referenceid=c.id"
		. "\n LEFT JOIN #__users AS u ON m.referenceid=u.id"
		. "\n LEFT JOIN #__session AS s ON s.userid=u.id"	
		. "\n WHERE m.memberid=". $userid ." and m.pending=1"
		. "\n AND c.approved=1 AND u.block=0 AND c.confirmed=1 "
		;
		$database->setQuery( $query );
		$objects = $database->loadObjectList();	
		return $objects;	
	}
	function getActiveConnections($userid) {
		global $database;
		$query = "SELECT DISTINCT m.*,u.name,u.email,u.username,c.avatar,c.avatarapproved, u.id, IF(s.session_id=null,0,1) AS 'isOnline' "
		. "\n FROM #__comprofiler_members AS m"
		. "\n LEFT JOIN #__comprofiler AS c ON m.memberid=c.id"
		. "\n LEFT JOIN #__users AS u ON m.memberid=u.id"
		. "\n LEFT JOIN #__session AS s ON s.userid=u.id"	
		. "\n WHERE m.referenceid=". $userid .""
		. "\n AND c.approved=1 AND u.block=0 AND c.confirmed=1 AND m.accepted=1"
		. "\n ORDER BY m.accepted "
		;
		$database->setQuery( $query );
		$objects = $database->loadObjectList();	
		return $objects;	
	}
	function getConnectedToMe($userid) {
		global $database;
		$query = "SELECT DISTINCT m.*,u.name,u.email,u.username,c.avatar,c.avatarapproved, u.id, IF(s.session_id=null,0,1) AS 'isOnline' "
		. "\n FROM #__comprofiler_members AS m"
		. "\n LEFT JOIN #__comprofiler AS c ON m.referenceid=c.id"
		. "\n LEFT JOIN #__users AS u ON m.referenceid=u.id"
		. "\n LEFT JOIN #__session AS s ON s.userid=u.id"	
		. "\n WHERE m.memberid=". $userid ." and m.pending=0"
		. "\n AND c.approved=1 AND u.block=0 AND c.confirmed=1 "
		;
		$database->setQuery( $query );
		$objects = $database->loadObjectList();	
		return $objects;	
	}

	function saveConnection($connectionid,$desc=null,$contype=null) {
		global $database;

		$sql="UPDATE #__comprofiler_members SET description='".htmlspecialchars(cbGetEscaped($desc))."', type='".htmlspecialchars(cbGetEscaped($contype))."' WHERE referenceid=".$this->referenceid." AND memberid=".cbGetEscaped($connectionid);
		$database->SetQuery($sql);
		if (!$database->query()) {
			$this->_setErrorMSG("SQL error" . $database->stderr(true));
			return 0;
		}
		return 1;
	}

	
	function _getDegreeOfSepArray($fromid) {
		global $database;
		
		$degree = 3;		// changing this to more may overload your server and shut it down. time is exponential. You've been warned.
		
		if ($degree==2) {
$sql="SELECT DISTINCT a.referenceid, a.memberid AS d1,  b.memberid AS d2 "
."\n FROM `#__comprofiler_members` AS a "
."\n LEFT JOIN  #__comprofiler_members AS b ON a.memberid=b.referenceid AND b.accepted=1 AND b.pending=0 AND b.memberid NOT IN ( $fromid,a.memberid) "
."\n WHERE a.referenceid = $fromid AND a.accepted=1 AND a.pending=0 "
."\n ORDER BY a.memberid,b.memberid ";
		}
		elseif ($degree==3) {
$sql="SELECT DISTINCT a.referenceid, a.memberid AS d1,  b.memberid AS d2,  c.memberid AS d3 "
."\n FROM `#__comprofiler_members` AS a "
."\n LEFT JOIN  #__comprofiler_members AS b ON a.memberid=b.referenceid AND b.accepted=1 AND b.pending=0 AND b.memberid NOT IN ( $fromid,a.memberid) "
."\n LEFT JOIN  #__comprofiler_members AS c ON b.memberid=c.referenceid AND c.accepted=1 AND c.pending=0 AND c.memberid NOT IN ( $fromid,a.memberid,b.memberid) "
."\n WHERE a.referenceid = $fromid AND a.accepted=1 AND a.pending=0 "
."\n ORDER BY a.memberid,b.memberid,c.memberid ";
		}
		elseif ($degree==4) {
$sql="SELECT DISTINCT a.referenceid, a.memberid AS d1,  b.memberid AS d2,  c.memberid AS d3,  d.memberid AS d4 "
."\n FROM `#__comprofiler_members` AS a "
."\n LEFT JOIN  #__comprofiler_members AS b ON a.memberid=b.referenceid AND b.accepted=1 AND b.pending=0 AND b.memberid NOT IN ( $fromid,a.memberid) "
."\n LEFT JOIN  #__comprofiler_members AS c ON b.memberid=c.referenceid AND c.accepted=1 AND c.pending=0 AND c.memberid NOT IN ( $fromid,a.memberid,b.memberid) "
."\n LEFT JOIN  #__comprofiler_members AS d ON c.memberid=d.referenceid AND d.accepted=1 AND d.pending=0 AND d.memberid NOT IN ( $fromid,a.memberid,b.memberid,c.memberid) "
."\n WHERE a.referenceid = $fromid AND a.accepted=1 AND a.pending=0 "
."\n ORDER BY a.memberid,b.memberid,c.memberid,d.memberid ";
		}
		elseif ($degree==6) {
$sql="SELECT DISTINCT a.referenceid, a.memberid AS d1,  b.memberid AS d2,  c.memberid AS d3,  d.memberid AS d4,  e.memberid AS d5,  f.memberid AS d6 "
."\n FROM `#__comprofiler_members` AS a "
."\n LEFT JOIN  #__comprofiler_members AS b ON a.memberid=b.referenceid AND b.accepted=1 AND b.pending=0 AND b.memberid NOT IN ( $fromid,a.memberid) "
."\n LEFT JOIN  #__comprofiler_members AS c ON b.memberid=c.referenceid AND c.accepted=1 AND c.pending=0 AND c.memberid NOT IN ( $fromid,a.memberid,b.memberid) "
."\n LEFT JOIN  #__comprofiler_members AS d ON c.memberid=d.referenceid AND d.accepted=1 AND d.pending=0 AND d.memberid NOT IN ( $fromid,a.memberid,b.memberid,c.memberid) "
."\n LEFT JOIN  #__comprofiler_members AS e ON d.memberid=e.referenceid AND e.accepted=1 AND e.pending=0 AND e.memberid NOT IN ( $fromid,a.memberid,b.memberid,c.memberid,d.memberid) "
."\n LEFT JOIN  #__comprofiler_members AS f ON e.memberid=f.referenceid AND f.accepted=1 AND f.pending=0 AND f.memberid NOT IN ( $fromid,a.memberid,b.memberid,c.memberid,d.memberid,e.memberid) "
."\n WHERE a.referenceid = $fromid AND a.accepted=1 AND a.pending=0 "
."\n ORDER BY a.memberid,b.memberid,c.memberid,d.memberid,e.memberid,f.memberid ";
		}
		$database->setQuery( $sql );

		if(method_exists($database,'loadAssocList')) $congroups = $database->loadAssocList();
		else {  //TODO drop this once we are dedicated to >= 4.5.2
			$cur = $database->query();
			$congroups = array();
			while ($row = mysql_fetch_assoc( $cur )) {
					$congroups[] = $row;
			}
		}
		return $congroups;
	}
	function getDegreeOfSepPath($fromid,$toid) {
		global $database;
		
		$congroups=$this->_getDegreeOfSepArray($fromid);
		if(count($congroups)>0) {
			$d1=$database->loadResultArray(1);
			$d2=$database->loadResultArray(2);
			$d3=$database->loadResultArray(3);
			$d4=$database->loadResultArray(4);
			$d5=$database->loadResultArray(5);
			$d6=$database->loadResultArray(6);
		
			if(array_search($toid,$d1)>-1) { 
				$rowNum=array_search($toid,$d1);
				$this->degreeOfSep=1;
			} elseif(array_search($toid,$d2)>-1) { 
				$rowNum=array_search($toid,$d2);
				$this->degreeOfSep=2;
			} elseif(array_search($toid,$d3)>-1) { 
				$rowNum=array_search($toid,$d3);
				$this->degreeOfSep=3;
			} elseif(array_search($toid,$d4)>-1) { 
				$rowNum=array_search($toid,$d4);
				$this->degreeOfSep=4;
			} elseif(array_search($toid,$d5)>-1) { 
				$rowNum=array_search($toid,$d5);
				$this->degreeOfSep=5;
			} elseif(array_search($toid,$d6)>-1) { 
				$rowNum=array_search($toid,$d6);
				$this->degreeOfSep=6;
			} else {
				$this->degreeOfSep=0;
				$rowNum=0;
			}

			$congroups=array_slice($congroups[$rowNum],0,$this->degreeOfSep+1);
		}
		return $congroups;
	}
	function getConnectionDetails($fromid,$toid) {
		global $database;
		$query = "SELECT * "
		. "\n FROM #__comprofiler_members AS m"
		. "\n WHERE m.referenceid=".$fromid." AND m.memberid=".$toid
		;
		
		$database->setQuery( $query );
		$connections = $database->loadObjectList();
		if ($connections && count($connections)>0)	return $connections[0];
		else return false;
	}
	function getDegreeOfSep() {
		return $this->degreeOfSep;
	}
	function _setDegreeOfSep($deg) {
		$this->degreeOfSep=$deg;
		return;
	}
	function getUserMSG() {
		return $this->userMSG;
	}
	function _setUserMSG($msg) {
		$this->userMSG=$msg;
		return;
	}
	function getErrorMSG() {
		return $this->errorMSG;
	}
	function _setErrorMSG($msg) {
		$this->errorMSG=$msg;
		return;
	}
}	// end class cbConnection

/**
* Notification Class for handeling CB notifications
* @package Community Builder
* @author MamboJoe
*/
class cbNotification {
	/**	@var errorMSG should be used to store the error message when an error is encountered*/
	var $errorMSG;
	/**	@var errorNum should be used to store the error number when an error is encountered*/
	var $errorNum;
	
	function cbNotification() {
	}
	function sendFromUser($toid,$fromid,$subject,$message, $messageEmail=null) {		//BB: add html email notifications processing later
		global $ueConfig;

		if ($messageEmail === null) $messageEmail = $message;
		SWITCH($ueConfig['conNotifyType']) {
			case 1:
				return $this->sendUserEmail($toid,$fromid,$subject,$messageEmail);
			break;
			case 2:
				return $this->sendUserPMSmsg($toid,$fromid,$subject,$message, true);
			break;
			case 3:
				$resultPMS	 = $this->sendUserPMSmsg($toid,$fromid,$subject,$message, true);
				$resultEmail = $this->sendUserEmail($toid,$fromid,$subject,$messageEmail);
				return $resultPMS && $resultEmail;
			break;
			default:
				return false;
			break;		
		}
	}
	function sendUserPMSmsg($toid,$fromid,$subject,$message, $systemGenerated=false) {
		global $_CB_PMS;
		if ($systemGenerated) $message = '<div style="padding: 4px; margin: 4px 3px 6px 0px; background: #C44; font-weight: bold;" class="cbNotice">'
										._UE_SENDPMSNOTICE . "</div>\n\n" . $message;
		$resultArray = $_CB_PMS->sendPMSMSG($toid,$fromid,$subject,$message,$systemGenerated);
		if (count($resultArray) > 0) return $resultArray[0];
		else return false;
	}
	function sendUserEmail($toid,$fromid,$subject,$message,$revealEmail=false) {
		global $database,$ueConfig,$my,$_SERVER,$mosConfig_live_site,$mosConfig_sitename;

		$rowFrom = new mosUser( $database );
		$rowFrom->load( $fromid );

		$rowTo = new mosUser( $database );
		$rowTo->load( $toid );
		$uname=getNameFormat($rowFrom->name,$rowFrom->username,$ueConfig['name_format']);
		if ($revealEmail) {
			if (isset($ueConfig['allow_email_replyto']) && $ueConfig['allow_email_replyto'] == 2) {
				$rowFrom->replytoEmail = $rowFrom->email;
				$rowFrom->replytoName  = $uname;
				$rowFrom->email = $ueConfig['reg_email_from'];
			} else {	// if (!isset($ueConfig['allow_email_replyto']) || $ueConfig['allow_email_replyto'] == 1)
				$rowFrom->replytoEmail = null;
				$rowFrom->replytoName  = null;
				$rowFrom->email = $rowFrom->email;
			}
		} else {
			$rowFrom->replytoEmail = null;
			$rowFrom->replytoName  = null;
			$rowFrom->name = _UE_NOTIFICATIONSAT." ".$mosConfig_sitename;
			$rowFrom->email = $ueConfig['reg_email_from'];
			$message.="\n\n".sprintf(_UE_EMAILFOOTER,$mosConfig_sitename,$mosConfig_live_site);
		}
		return $this->_sendEmailMSG( $rowTo, $rowFrom, $subject, $message, $revealEmail );
	}
	function sendFromSystem( $toid, $sub, $message, $replaceVariables = true ) {
		global $database,$ueConfig,$mosConfig_sitename,$mosConfig_live_site;

		$rowFrom=null;
		$rowFrom->email = $ueConfig['reg_email_from'];
		$rowFrom->name = $ueConfig['reg_email_name'];
		$rowFrom->replytoEmail = $ueConfig['reg_email_replyto'];
		$rowFrom->replytoName = $ueConfig['reg_email_name'];
		
		if(!is_object($toid)) {
			$query = "SELECT * FROM #__comprofiler c, #__users u WHERE c.id=u.id AND c.id =" . cbGetEscaped($toid);
			$database->setQuery($query);
			$rowTo = $database->loadObjectList();
			$rowTo = $rowTo[0];
		} else {
			$rowTo = $toid;
		}

		if ($replaceVariables) {
			$message = $this->_replaceVariables($message,$rowTo);
		}
		$message.="\n\n".sprintf(_UE_EMAILFOOTER,$mosConfig_sitename,$mosConfig_live_site);
		$message = str_replace(array("\\","\"","\$"), array("\\\\","\\\"","\\\$"), $message);
		eval ("\$message = \"$message\";");	
	
		return $this->_sendEmailMSG($rowTo,$rowFrom,$mosConfig_sitename.'-'.$sub,$message,FALSE);
	
	}
	function sendToModerators( $sub, $message ) {
		global $database,$ueConfig;
		$database->setQuery( "SELECT u.id FROM #__users u INNER JOIN #__comprofiler c ON u.id=c.id"
		."\n WHERE u.gid IN (".implode(',',getParentGIDS($ueConfig['imageApproverGid'])).") AND u.block=0 AND c.confirmed=1 AND c.approved=1 AND u.sendEmail=1" );
		$mods = $database->loadObjectList();
		foreach ($mods AS $mod) {
			$this->sendFromSystem($mod->id, $sub, $message, false);
		}

	}
	
	function _sendEmailMSG($to,$from,$sub,$msg,$addPrefix=FALSE) {			//BB: add html
		global $_SERVER,$ueConfig,$mosConfig_sitename,$mosConfig_live_site;
		
		if($addPrefix) {
			$uname=getNameFormat($from->name,$from->username,$ueConfig['name_format']);
			$premessage = sprintf(_UE_SENDEMAILNOTICE, $uname, $mosConfig_sitename, $mosConfig_live_site);
			if (isset($ueConfig['allow_email_replyto']) && $ueConfig['allow_email_replyto'] == 2) {
				$premessage .= sprintf(_UE_SENDEMAILNOTICE_REPLYTO, $uname, $from->email);
			}
			$premessage .= sprintf(_UE_SENDEMAILNOTICE_DISCLAIMER, $mosConfig_sitename);
			$premessage .= sprintf(_UE_SENDEMAILNOTICE_MESSAGEHEADER, $uname);
			$msg=$premessage.$msg;
			$from->name = $from->name . " @ ". $mosConfig_sitename;		// $ueConfig['reg_email_name']
		}
		if (class_exists("mosPHPMailer")) {
			$res = comprofilerMail($from->email, $from->name, $to->email, $sub, $msg, 0, NULL, NULL, NULL, $from->replytoEmail, $from->replytoName );
		} else if (function_exists( 'mosMail' )) {
			$res = mosMail($from->email, $from->name, $to->email, $sub, $msg);
		} else { //TODO drop this once we are dedicated to >= 4.5.2
			$header  = "MIME-Version: 1.0\r\n";
			$header .= "Content-type: text/plain; charset=iso-8859-1\r\n";
			$header .= "Organization: ".$mosConfig_sitename."\r\n";
			$header .= "Content-Transfer-encoding: 8bit\r\n";
			$fromTag  = $from->name." <" . $from->email . ">";
			$header .= "From: ".$fromTag."\r\n";
			$replyTag = $from->replyName." <" . $from->replyEmail . ">";
			$header .= "Reply-To: ".$replyTag."\r\n";
			$header .= "Message-ID: <".md5(uniqid(time()))."@{$_SERVER['SERVER_NAME']}>\r\n";
			$header .= "Return-Path: ".$from->email."\r\n";
			$header .= "X-Priority: 3\r\n";
			$header .= "X-MSmail-Priority: Low\r\n";
			$header .= "X-Mailer: PHP\r\n"; //hotmail and others dont like PHP mailer. --Microsoft Office Outlook, Build 11.0.5510
			$header .= "X-Sender: ".$from->email."\r\n";
			$res =  mail($to->email, $sub, $msg, $header);
		}
		return $res;
	}
	function _getUserDetails($row,$includePWD) {
		$uDetails = _UE_EMAIL." : ".$row->email;
		$uDetails .= "\n"._UE_UNAME." : ".$row->username."\n";
		if($includePWD==1) $uDetails .= _UE_PASS." : ".$row->password."\n";
	 	return $uDetails;
	}

	function _replaceVariables($msg, $row){
		global $mosConfig_live_site, $mosConfig_absolute_path,$ueConfig,$mosConfig_emailpass;
		
		if($ueConfig['reg_confirmation']==1) $confirmLink = " \n".$mosConfig_live_site."/index.php?option=com_comprofiler&task=confirm&confirmcode=".md5($row->id)." \n";		//BB no sef here ! added space after link for dumb emailers (Ms Entourage)
		else $confirmLink = ' ';

		eval ("\$msg = \"$msg\";");			// compensate for wrong language definitions (using '\n' instaed of "\n")
		$msg = cbstr_ireplace("[USERNAME]", $row->username, $msg);
		$msg = cbstr_ireplace("[NAME]", $row->name, $msg);
		$msg = cbstr_ireplace("[EMAILADDRESS]", $row->email, $msg);
		$msg = cbstr_ireplace("[SITEURL]", $mosConfig_live_site, $msg);
		$msg = cbstr_ireplace("[DETAILS]", $this->_getUserDetails($row,$mosConfig_emailpass), $msg);
		$msg = cbstr_ireplace("[CONFIRM]", $confirmLink, $msg );
		$array = array();
		$array=get_object_vars($row);
		foreach( $array AS $k=>$v) {
			if(!is_object($v)) {
				if (!(strtolower($k) == "password" && strlen($v) >= 32)) {
					$msg = cbstr_ireplace("[".$k."]", getLangDefinition($v), $msg );
				}
			}
		}
		return $msg;
	}
}	// end class cbNotification

class cbFields {
	/**	@var errorMSG should be used to store the error message when an error is encountered*/
	var $errorMSG;
	/**	@var errorNum should be used to store the error number when an error is encountered*/
	var $errorNum;
	
	function cbFields() {
		
		
	}
	
	function prepareFieldDataView() {

	}
	
	function prepareFieldDataSave($fieldType,$fieldName,$value=null) {
				global $ueConfig,$_POST;
			$sqlFormat = "Y-m-d";
		switch($fieldType) {
		CASE 'date': 
			$value=dateConverter(cbGetUnEscaped($value),$ueConfig['date_format'],$sqlFormat);
		break;
		CASE 'webaddress':
			if (isset($_POST[$fieldName."Text"]) && ($_POST[$fieldName."Text"])) {
				$oValuesArr=array();
				$oValuesArr[0]=str_replace(array('mailto:','http://','https://'),'',
								cbGetUnEscaped($value));
				$oValuesArr[1]=str_replace(array('mailto:','http://','https://'),'',
								cbGetUnEscaped((isset($_POST[$fieldName."Text"]) ? $_POST[$fieldName."Text"] : "")));
				$value = implode("|*|",$oValuesArr);
			} else {
				$value= str_replace(array('mailto:','http://','https://'),'',cbGetUnEscaped($value));
			}
		break;
		CASE 'emailaddress': 
			$value=str_replace(array('mailto:','http://','https://'),'',cbGetUnEscaped($value));
		break;
		CASE 'editorta': 
			$value=cbGetUnEscaped($value);
		break;
		case 'multiselect':
		case 'multicheckbox':
		case 'select':
			if ($value === null) $value = array();
			$value=cbGetUnEscaped(implode("|*|",$value));
		break;
		case 'checkbox':
//		case 'radio':		// don't do that to avoid un-checking with browser-hack
			if ($value === null) $value = "";
			$value=cbGetUnEscaped($value);
		break;
		case 'delimiter':
		break;
		DEFAULT:
			$value=cbGetUnEscaped($value);
		break;
		}
		return $value;
		
	}
	
	function getErrorMSG() {
		return $this->errorMSG;
	}
	function _setErrorMSG($msg) {
		$this->errorMSG=$msg;
		return;
	}
}	// end class cbFields


// ----- NO MORE CLASSES OR FUNCTIONS PASSED THIS POINT -----
// Post class declaration initialisations
// some version of PHP don't allow the instantiation of classes
// before they are defined

/** @global cbPMS $_CB_PMS */
$_CB_PMS = new cbPMS();

?>
